// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap;

import com.bbn.openmap.util.PropUtils;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Properties;
import java.util.logging.Level;

/**
 *
 * @author jchauvea
 */
public class PropertyHandler extends com.bbn.openmap.PropertyHandler{

        public PropertyHandler(URL url) throws IOException {
        DEBUG = logger.isLoggable(Level.FINE);
        InputStream is = null;

        if (url != null) {
            // Open URL to read in properties
            is = url.openStream();
        }

        Properties tmpProperties = new Properties();
        if (is != null) {
            tmpProperties.load(is);
        }

        init(tmpProperties, "URL");
        Environment.init(getProperties());
    }

    /**
     * Constructor to take Properties object as argument, to create context for
     * a particular map.
     */
    public PropertyHandler(Properties props) {
        DEBUG = logger.isLoggable(Level.FINE);
        init(props, null);
        Environment.init(getProperties());
    }

      public PropertyHandler(String urlString) throws MalformedURLException,
            IOException {
        super(PropUtils.getResourceOrFileOrURL(urlString));
    }
}
