// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.animation;

import fr.unicaen.openmap.animation.gui.CascadePanel;
import javax.swing.JComponent;

/**
 *
 * @author jchauvea
 */
public class AnimationDSChainCascade {

    private AnimationDSChain slave;
    private AnimationDSChain master;
    private CascadePanel gui;

    public AnimationDSChainCascade(AnimationDSChain master, AnimationDSChain slave){
        this.master = master;
        this.slave = slave;
	master.setCascade(this);
    }

    public boolean isConnected() {
	return master.getSlave() == slave;
    }

    public void toggleConnect() {
	if (isConnected())
	    disconnect();
	else
	    connect();
    }

    public void connect(){
        master.setSlave(slave);
        slave.setMaster(master);

    }

    public void disconnect(){
        master.setSlave(null);
        slave.setMaster(null);
    }

    public JComponent getGUI(){
        if(gui == null)
            gui = new CascadePanel(this);
        return gui;
    }

    public void turnIcon() {
	if (gui == null)
	    return;
	((CascadePanel)gui).turnIcon();
    }
}
