// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.animation.gui;

import fr.unicaen.openmap.animation.AnimationDSChainCascade;
import fr.unicaen.openmap.util.Util;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

/**
 *
 * @author jchauvea
 */
public class CascadePanel extends JPanel{

    private JButton button;
    private boolean iconCascade = true;
    Icon cascade0 = Util.loadIcon("cascade.png");
    Icon cascade1 = Util.loadIcon("cascade2.png");
    Icon nocascade = Util.loadIcon("no-cascade.png");
    
    public CascadePanel(final AnimationDSChainCascade cascade){
        button = new JButton(cascade.isConnected() ? cascade0 : nocascade);
        add(button);
        button.setBorder(null);
        button.setBackground(Color.gray);
        button.setOpaque(false);
        button.setFocusPainted(false);
        button.setBorderPainted(false);
        setBorder(null);

        button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent arg0) {
		cascade.toggleConnect();
                button.setIcon(cascade.isConnected() ? cascade0 : nocascade);
            }
        });
    }

    public void turnIcon() {
	button.setIcon(iconCascade ? cascade1 : cascade0);
	iconCascade = ! iconCascade;
    }
}
