// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.app;



import javax.swing.UIManager;



import com.bbn.openmap.gui.MapPanel;

import fr.unicaen.openmap.Environment;
import fr.unicaen.openmap.gui.SplashScreen;

/**
 * The OpenMap application framework. This class creates a PropertyHandler that
 * searches the classpath, config directory and user's home directory for an
 * openmap.properties file, and creates the application based on the contents of
 * the properties files. It also creates an MapPanel and an OpenMapFrame to be
 * used for the application and adds them to the MapHandler contained in the
 * MapPanel. All other components are added to that MapHandler as well, and they
 * use the MapHandler to locate, connect and communicate with each other.
 */
public class ThemaMapWebStart {

    public static final String defaultPropertiesFile = "http://themamap.info.unicaen.fr/wp-includes/themamapws/openmap.properties";

    protected MapPanel mapPanel;
  
    /**
     * The main OpenMap application.
     */
    /*public static void main(String args[]){
    ThemaMap th = ThemaMap.create("exemple.properties");
    }*/
    static public void main(String args[]) {
        try {
            SplashScreen splash = new SplashScreen();
            splash.show();
            //UIManager.setLookAndFeel(new SubstanceCremeLookAndFeel());
            UIManager.put("swing.boldMetal", Boolean.FALSE);
            String propertiesFile = defaultPropertiesFile;
            if(args.length == 1)
                propertiesFile = "http://themamap.info.unicaen.fr/wp-includes/themamapws/"+args[0];
            //System.out.println("Properties file = " + propertiesFile);
            Environment.setJWS(true);
            ThemaMap.create(propertiesFile);

            splash.close();
        } catch (Exception e) {
            e.printStackTrace();
        }


    }
}

