// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
/*
 * RemovableInformationDataStorage.java
 *
 * Created on july 2011
 *
 * @author Jacques.Madelaine@info.unicaen.fr
 *
 */
package fr.unicaen.openmap.dataStorage;

import com.bbn.openmap.util.Debug;

import fr.unicaen.openmap.dataStorage.gui.DataTableModel;
import fr.unicaen.openmap.dataStorage.gui.DataTableStoragePanel;

public abstract class RemovableInformationDataStorage extends InformationDataStorage implements RemovableDataStorage {       

    public RemovableInformationDataStorage(DataStorageListener dsl, DataStorage dataStorage) {
	super(dsl);
	_dataStorage = dataStorage;
        if (_dataStorage != null) // we are now the listener
	    _dataStorage.setDataStorageListener(this);	
        dataTableModel = new DataTableModel(dataTable);
        dtsp = new DataTableStoragePanel(this, dataTableModel);
    }

    /** returns the original underlying DataStorage and update the listeners */
    public DataStorage removeItSelf() {
	getDataStorage().setDataStorageListener(getDataStorageListener());
        getDataStorage().fireDataStorageEvent();
        return getDataStorage();
    }

    private DataStorage _dataStorage;

    /** returns the underlying DataStorage */
    public DataStorage getDataStorage() {
	return _dataStorage;
    }

    public void setDataStorage(DataStorage dataStorage) {
        _dataStorage = dataStorage;
    }

    public void dataStorageEvent(DataStorage source) {
        Debug.message("DataStorage", classNameForDebug + " dataStorageEvent <== " + source);
        if (getDataStorage() != null && getDataStorage().isReady()) {
            Debug.message("DataStorage", classNameForDebug + " data ready ***");
            initialize();
        }
    }

}
