// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.gml.out;

import com.bbn.openmap.omGraphics.OMRect;
import com.vividsolutions.jts.geom.Coordinate;
import fr.unicaen.openmap.jts.JTSFactory;

/**
 *
 * @author jchauvea
 */
public class GMLRect {

    private OMRect rect;

    public GMLRect(OMRect omr) {
        this.rect = omr;
    }

    public String toString() {
        Coordinate[] coordinates = JTSFactory.extractCoordinates(rect);
        String coords = "";
        for (Coordinate c : coordinates) {
            coords += c.y + " " + c.x + " ";
        }
        //remove last " "
        return coords.substring(0, coords.length() - 1);
    }
}
