// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
// <header>
/**
 *  Themamap: The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */

package fr.unicaen.openmap.dataStorage.gui;

import javax.swing.event.TableModelEvent;
import fr.unicaen.openmap.dataStorage.gui.DataTableModel;
import fr.unicaen.openmap.dataStorage.*;

public class DataTableModelNetCDF extends DataTableModel {

    protected NetCDFDataStorage ds = null;

    public DataTableModelNetCDF(NetCDFDataStorage ds ) {
		super(null);
        this.ds = ds;
    }

    public int getRowCount() {
        return ds == null ? 0 : ds.getCount();
    }

    public int getColumnCount() {
        return ds == null ? 0 : ds.getColumnCount();
    }

    public Object getValueAt(int row, int col) {
		DataObject dobj = ds.getElementAt(row);
		String colName = ds.getColumnName(col);
        return dobj == null ? null : dobj.getData(colName);
    }

    public String getColumnName(int column) {
        return ds.getColumnName(column);
    }

    public String getRealColumnName(int column) {
        return getColumnName(column);
    }

    public boolean isCellEditable(int row, int col) {
        return false;
    }

    public Class getColumnClass(int c) {
        try {
            return getValueAt(0, c).getClass();
        } catch (java.lang.NullPointerException e) {
            return "".getClass();
        }
    }

    public int getOMColumnCount() {
        return ds.getOMColumnCount();
    }

    public String getOMColumnName(int c) {
        return ds.getOMColumnName(c);
    }

    public String getRealOMColumnName(int c) {
        return getOMColumnName(c);
    }

    public String[] getDataColumnNames() {
        String[] dataColumnNames = new String[getColumnCount()];
        for (int i = 0; i < getColumnCount(); i++) {
            dataColumnNames[i] = getColumnName(i);
        }
        return dataColumnNames;
    }

    public String[] getOMColumnNames() {
        String[] omColumnNames = new String[getOMColumnCount()];
        for (int i = 0; i < getOMColumnCount(); i++) {
            omColumnNames[i] = getOMColumnName(i);
        }
        return omColumnNames;
    }

    public int getIndexForColumnName(String name) {
        if (name == null) {
            return -1;
        }
        for (int i = 0; i < getColumnCount(); i++) {
            if (name.equals(getColumnName(i))) {
                return i;
            }
        }
        return -1;
    }

    public int getIndexForOMColumnName(String name) {
        if (name == null) {
            return -1;
        }
        for (int i = 0; i < getOMColumnCount(); i++) {
            if (name.equals(getOMColumnName(i))) {
                return i;
            }
        }
        return -1;
    }

    public DataTable getTable() {
        return null;
    }

    public Object[] getValues(String colName){
        int indexCol = getIndexForColumnName(colName);
        Object[] values = new Object[getRowCount()];
        for(int i = 0; i < getRowCount(); i++){
            values[i] = getValueAt(i, indexCol);
        }
        return values;

    }

    public DataObject getDataObjectAt(int row){
        return ds.getElementAt(row);
    }
}
