// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.kml;


import org.w3c.dom.Element;

public class KMLCircle implements KMLElement{

	
	public static String genCircle(double centerlat_form, double centerlong_form, int num_points, double radius_form, double startAngle){
		double lat1, long1;
		double d_rad;
		double d;
		double radial, lat_rad, dlon_rad, lon_rad;


		// convert coordinates to radians
		lat1 = Math.toRadians(centerlat_form);
		long1 = Math.toRadians(centerlong_form);

		//Earth measures
		d = radius_form;
		d_rad = d/6378137;

		StringBuffer coords = new StringBuffer();
		coords.append(centerlong_form+","+centerlat_form+",0\n");
		// loop through the array and write path linestrings
		for(int i=0; i<=num_points; i++) {
		//delta_pts = 360/(double)num_points;
		//radial = Math.toRadians((double)i*delta_pts);
		radial = Math.toRadians((double)(i+startAngle));

		//This algorithm is limited to distances such that dlon <pi/2
		lat_rad = Math.asin(Math.sin(lat1)* Math.cos(d_rad) + Math.cos(lat1)* Math.sin(d_rad)* Math.cos(radial));
		dlon_rad = Math.atan2(Math.sin(radial)* Math.sin(d_rad)* Math.cos(lat1), Math.cos(d_rad)- Math.sin(lat1)* Math.sin(lat_rad));
		lon_rad = ((long1 + dlon_rad + Math.PI) % (2*Math.PI)) - Math.PI;

		
		//write results
		coords.append(Math.toDegrees(lon_rad) + ", ");
		coords.append(Math.toDegrees(lat_rad) + ", 0");
		coords.append('\n');
		}

		coords.append(centerlong_form+","+centerlat_form+",0\n");
		return coords.toString();
	}

	public Element toKml(KMLDocument doc) {
		// TODO Auto-generated method stub
		return null;
	}

	public void exportWithStax(KMLWriter writer) {
		// TODO Auto-generated method stub
		
	}
}



