// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.kml;

import java.awt.Color;
import java.util.ArrayList;

import org.apache.batik.dom.GenericDOMImplementation;
import org.w3c.dom.Attr;
import org.w3c.dom.CDATASection;
import org.w3c.dom.Comment;
import org.w3c.dom.DOMConfiguration;
import org.w3c.dom.DOMException;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;
import org.w3c.dom.DocumentType;
import org.w3c.dom.Element;
import org.w3c.dom.EntityReference;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.ProcessingInstruction;
import org.w3c.dom.Text;
import org.w3c.dom.UserDataHandler;


public class KMLDocument {
	
	public final static String NAME_SPACE = "http://earth.google.com/kml/2.2" ;
	
	public  ArrayList<String> colors;

	private Document document;

	private Element kmlRoot;
	
	private Element docRoot;
	
	
	public KMLDocument(){
		DOMImplementation domImpl = GenericDOMImplementation.getDOMImplementation();
		document = domImpl.createDocument(NAME_SPACE, "kml", null);
		kmlRoot = document.getDocumentElement();
		kmlRoot.setAttributeNS(null, "xmlns", NAME_SPACE);
		docRoot = document.createElement("Document");
		kmlRoot.appendChild(docRoot);
		colors = new ArrayList<String>();
                //System.out.println(document.toString());
		
	}

	public String addStyle(/*Color color*/String color){
		/*StringBuffer c = new StringBuffer();
		String tmp = Integer.toHexString(color.getRed());
		if(tmp.equals("0"))
			tmp="00";
		c.append(tmp);
		tmp = Integer.toHexString(color.getGreen());
		if(tmp.equals("0"))
			tmp="00";
		c.append(tmp);
		tmp = Integer.toHexString(color.getBlue());
		if(tmp.equals("0"))
			tmp="00";
		c.append(tmp);
		tmp = Integer.toHexString(color.getAlpha());
		if(tmp.equals("0"))
			tmp="00";
		c.append(tmp);*/
		
		if(!colors.contains(color))
			{
				colors.add(color);
				docRoot.insertBefore(buildStyle(color), 
						docRoot.getFirstChild());
			}
		return "#style"+color;
		
	}
	
	private Element buildStyle(String color){
		Element style = document.createElement(KMLConstants.KML_STYLE);
		style.setAttribute(KMLConstants.KML_ID, "style"+color);
		Element pol = document.createElement(KMLConstants.KML_POLY_STYLE);
		Element col = document.createElement("color");
		col.appendChild(document.createTextNode(color));
		pol.appendChild(col);
		style.appendChild(pol);
		return style;
		
	}
	
	
	public Document getDocument(){return document;}
	
	public Element getKmlRoot(){return kmlRoot;}
	
	public Element getDocRoot(){return docRoot;}
	

}
