// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.kml;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JPanel;

import fr.unicaen.openmap.event.GUIChangeEvent;
import fr.unicaen.openmap.event.GUIChangeListener;
import fr.unicaen.openmap.gui.FileNamePanel;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import fr.unicaen.openmap.util.propertyEditor.FileTypeDescription;


public class KMLExportPanel extends JPanel implements ActionListener,GUIChangeListener,ItemListener  {
    

    /**
     * 
     */
    private static final long serialVersionUID = -1360849243306077536L;
    private ThematicDataDisplayLayer tddlayer;
    private JButton bExport;
    private JCheckBox checkAll;
    private KMLExporter kmlExporter;
    private FileNamePanel kmlPanel;
    private ArrayList<Thematic> themas;
    private ArrayList<Thematic> actives;
    private JCheckBox[] checkBoxes;
	
    public KMLExportPanel(ThematicDataDisplayLayer layer) {
	super();
	tddlayer = layer;
	kmlExporter = new KMLExporter();
	themas = tddlayer.getThematicArray();
	actives = new ArrayList<Thematic>();
	JPanel panCheck = new JPanel();
	checkAll = new JCheckBox("Export all visible layers");
	checkAll.setSelected(true);
	checkAll.addItemListener(this);
	panCheck.add(checkAll);
	panCheck.setLayout(new GridLayout(themas.size()+1,1));
	checkBoxes = new JCheckBox[themas.size()];
	int i =0;
	for(Thematic thema: themas){
	    JCheckBox box = new JCheckBox(thema.getName());
	    panCheck.add(box);
	    checkBoxes[i] = box;
	    i++;
	    if(thema.isVisible())
		box.setSelected(true);
	    actives.add(thema);
	}
	bExport = new JButton("Export");

	kmlPanel = new FileNamePanel(FileTypeDescription.KML_DESCRIPTION, "", FileTypeDescription.KML_PATTERN, this);
	bExport.addActionListener(this);
	JPanel topPan = new JPanel();
	topPan.add(panCheck);
	topPan.add(kmlPanel);
	topPan.add(bExport);
	topPan.setBorder(BorderFactory.createTitledBorder("KML export"));
	setLayout(new BorderLayout());
	add(topPan,BorderLayout.NORTH);
    }
    
    public void reloadFromGUI(GUIChangeEvent event) {

	/*Object source = event.getSource();
	  if (source == shpPanel) {
	  String shpFile = shpPanel.getFilePath();
	  dbfPanel.setFilePath(shpFile.replaceFirst("\\.shp$",".dbf"));
	  } else if (source == dbfPanel) {
	  //nothing
	  } else {
	  Debug.message("DataStorage", "[ShapeFileDataStorage] GUIChangeEvent not processed");
	  }*/
    }

    public void actionPerformed(ActionEvent e) {
	/*if (e.getSource() == bExport) {
	  byte[] kmlDatas = kMLExporter.getTextFromLayers(tddlayer,actives);
	  FileOutputStream binFile;
	  try {
	  binFile = new FileOutputStream("test2.kml");
	  binFile.write(kmlDatas);
	  binFile.close();
	  } catch (FileNotFoundException e1) {e1.printStackTrace();}
	  catch (IOException e2) {e2.printStackTrace();}
	  }
	  if(e.getSource() == bBrowse){
	  JFileChooser fChooser = new JFileChooser();
	  if(fChooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION)
	  fileField.setText(fChooser.getSelectedFile().getName());
	  }*/
    }

    public void itemStateChanged(ItemEvent e) {
	boolean selected;
	if (e.getSource() == checkAll){
	    selected = checkAll.isSelected();
	    for(int i = 0; i<checkBoxes.length;i++ ){
		checkBoxes[i].setSelected(selected);
	    }
	}
    }
    
}
