// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.kml;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import com.bbn.openmap.omGraphics.OMText;

public class KMLPlacemark implements KMLElement{
	
	
	private Document document;
	
	private OMText omtext;
	
	public KMLPlacemark(OMText omtext) {
		this.omtext = omtext;
	}
	
	/**
	 * 
	 */
	public Element toKml(KMLDocument document) {
		
		//createElements();
		Document doc = document.getDocument();
		Element pl = doc.createElement(KMLConstants.KML_PLACEMARK);
		Element n = doc.createElement("name");
		Node ntxt = doc.createTextNode(omtext.getData());
		n.appendChild(ntxt);
		Element d = doc.createElement(KMLConstants.DESCRIPTION);
		Node dtxt = doc.createTextNode(omtext.getData()+
											"Coords: "+omtext.getLat()+","+												
											omtext.getLon()
										);
		d.appendChild(dtxt);
		Element p = doc.createElement("Point");
		Element c = doc.createElement(KMLConstants.KML_COORDINATES);
		Node ctxt = doc.createTextNode(omtext.getLon()+","+omtext.getLat());
		c.appendChild(ctxt);
		
		
		pl.appendChild(n);
		pl.appendChild(d);
		pl.appendChild(p);
		p.appendChild(c);
			
		return pl;
	}
	
	public void exportWithStax(KMLWriter writer){
		KMLExporter.NB_FIG++;
		writer.writePlacemarkDescription(String.valueOf(KMLExporter.NB_FIG), 
										"Coords: "+omtext.getLat()+","+	omtext.getLon(), 
										 omtext.getLon()+","+omtext.getLat());
		
	}

}
