// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.postgis.db;

import com.bbn.openmap.util.Debug;
import java.util.Vector;
import java.sql.*;

public class DBConnection {
    private DBState state = new DBState(0);
    /**
     *
     */
    private boolean connected;
    /**
     *
     */
    private DBParams params;
    /**
     *
     */
    private Connection connection;
    /**
     *
     */
    public DBConnection (DBParams params) {
	this.params = params;
    }
    /**
     *
     */    
    public DBConnection () { }
    /**
     *
     */    
    public String toString() {
	return "" + params;
    }

    public DBParams getParams () { return params; }
    public void setParams(DBParams params) { this.params = params; }
    // public void setConnected(boolean connected) { this.connected = connected; }
    public boolean isConnected() { return connection != null; /* connected; */}
    public Connection getConnection() { return connection; }
    public void setConnection(Connection c) { connection = c; }
    public long getState() { return state.getState(); }
    
    public void closeConnection() {
	try {
	    connection.close();
	} catch (Exception e) {
	    state = new DBState(DBState.CONNECT_ERROR);
	    errorString = e.getMessage();
	    if (Debug.debugging("DBConnection")){
		e.printStackTrace();
	    }
	}
	connection = null;
    }
    
    public Vector<DBTable> getTables() {
	Vector<DBTable> v = new Vector<DBTable>();
	try {
	    DatabaseMetaData dbmd = connection.getMetaData();
	    String [] types = {"TABLE"};
	    ResultSet rs = dbmd.getTables(null, null, null, types);
	    ResultSetMetaData rsmd = rs.getMetaData();
	    while( rs.next() ) {
		// index of the table name is hardcoded !
		v.add(new DBTable(rs.getString(3)));
		/*
		  for (int j = 1 ; j <= rsmd.getColumnCount() ; j++) {
		  System.err.print("[" + rsmd.getColumnName(j) + ":" + rs.getString(j) + "]");
		  }
		  System.err.print("\n");
		*/
	    }
	    state = new DBState(DBState.CONNECT_OK);
	    errorString = "No Error";
	} catch (Exception e) {
	    state = new DBState(DBState.CONNECT_ERROR);
	    errorString = e.getMessage();
	    if (Debug.debugging("DBConnection")){
		e.printStackTrace();
	    }
	}
	return v;
    }
    
    String errorString = "";
    
    public String getErrorString() { return errorString; }
    
}
