// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.dataStorage.postgis.gui;

import com.bbn.openmap.Environment;
import com.bbn.openmap.I18n;
import fr.unicaen.openmap.dataStorage.postgis.PostgisDataStorage;


import java.awt.*;
import javax.swing.*;

/**
 * This class is used to display a database query. Display all panels in a JTabbedPane.
 * Contain selections realised by user.
 */
public class PostgisDataStoragePanel extends JPanel{
    //protected int nbSelections = 0;
    protected QueryPanel queryPanel;
    protected DBParamsPanel dbParamsPanel;

    protected I18n i18n = Environment.getI18n();

    public PostgisDataStoragePanel(QueryPanel queryPanel, DBParamsPanel dbParamsPanel) {
	super();
        this.queryPanel = queryPanel;
        this.dbParamsPanel = dbParamsPanel;
	setDoubleBuffered(true);
        add(queryPanel);
        add(dbParamsPanel);
        
	/*setLayout(new BorderLayout());
	
	tabs = new JTabbedPane();
	tabs.addTab("Query", Util.loadIcon("Query.png"), queryPanel);
	tabs.addTab("Database", Util.loadIcon("Database.png"), dbParamsPanel);
        add(tabs, BorderLayout.CENTER);*/
    }

    public void updateGUIWithState(PostgisDataStorage.DBState dbs){
        if(dbs == PostgisDataStorage.DBState.CONNECT_ERROR){
            ;
            JOptionPane.showMessageDialog(this,
                    i18n.get(this,"connection_error","Connection error - Check connection parameters"),
                    i18n.get(this,"error","Error"),
                    JOptionPane.ERROR_MESSAGE);
            dbParamsPanel.updateStateLabel(false);
        }
        else{
            if(dbs == PostgisDataStorage.DBState.QUERY_ERROR){
                JOptionPane.showMessageDialog(this, 
                        i18n.get(this,"query_error","Query - Check your sql query"),
                        "Error",
                        JOptionPane.ERROR_MESSAGE);
            }
            else
                dbParamsPanel.updateStateLabel(true);
        }
    }

}
