// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import com.bbn.openmap.gui.AbstractOpenMapMenu;
import com.bbn.openmap.gui.menu.MouseModeMenu;
import com.bbn.openmap.gui.menu.ToolPanelToggleMenuItem;
import javax.swing.*;

/**
 * 
 * @author jchauvea
 *
 */
public class DisplayMenu extends AbstractOpenMapMenu {

    protected LayersMenuItem layersMenuItem;
    protected NavigationMenuItem navigationMenuItem;
    protected ConfigurationMenuItem configurationMenuItem;

    public DisplayMenu() {
        super();
        setText(i18n.get(this, "control", "Control"));
        try {
            add(new MouseModeMenu());
            add(new BackgroundColorMenu());

            layersMenuItem = new LayersMenuItem();
            navigationMenuItem = new NavigationMenuItem();
            configurationMenuItem = new ConfigurationMenuItem();
            add(new JSeparator());
            add(layersMenuItem);
            add(navigationMenuItem);
            add(configurationMenuItem);
            //add(new InternalFrameMenuItem());
            // add(new ExternalFrameMenuItem());

            add(new ToolPanelToggleMenuItem());

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public ConfigurationMenuItem getConfigurationMenuItem() {
        return configurationMenuItem;
    }

    public void setConfigurationMenuItem(ConfigurationMenuItem configurationMenuItem) {
        this.configurationMenuItem = configurationMenuItem;
    }

    public LayersMenuItem getLayersMenuItem() {
        return layersMenuItem;
    }

    public void setLayersMenuItem(LayersMenuItem layersMenuItem) {
        this.layersMenuItem = layersMenuItem;
    }

    public NavigationMenuItem getNavigationMenuItem() {
        return navigationMenuItem;
    }

    public void setNavigationMenuItem(NavigationMenuItem navigationMenuItem) {
        this.navigationMenuItem = navigationMenuItem;
    }
}
