// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import com.bbn.openmap.Layer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.awt.Color;
import java.awt.Component;
import java.util.EventObject;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellEditor;

import fr.unicaen.openmap.layer.wmsLayer.DummyWMSLayer;
import fr.unicaen.openmap.layer.wmsLayer.WMSTreeNodeComponent;

public class LayerCellEditor extends DefaultTreeCellEditor {

    public LayerCellEditor(JTree tree, LayerCellRenderer renderer) {
        super(tree, renderer);
    }

    @Override
    public Component getTreeCellEditorComponent(JTree tree, Object value, 
						boolean isSelected, boolean expanded, boolean leaf, int row) {
        JComponent component;
        Object obj = ((DefaultMutableTreeNode) value).getUserObject();
        if (obj instanceof Thematic)
		{
            component = new ThematicTreeNodeComponent((LayersTree) tree, (Thematic) obj);
        }
		else
		if (obj instanceof DummyWMSLayer )
		{
			component = new WMSTreeNodeComponent( (LayersTree) tree, (DummyWMSLayer) obj );
		}
		else
		if (obj instanceof Layer)
		{
	    	if (tree instanceof AtlasLayersTree)
			{
				component = new AtlasLayerTreeNodeComponent((AtlasLayersTree) tree, (Layer) obj, (DefaultMutableTreeNode) value);
	    	}
			else
			{
				component = new LayerTreeNodeComponent((LayersTree) tree, (Layer) obj);
			}
		}
		else
		{
			component = new JPanel();
			component.add(new JLabel(value.toString()));
			component.setBackground(Color.WHITE);
		}
        
        editingContainer = component;
        component.setBackground(Color.LIGHT_GRAY);
        return component;
    }

    @Override
    public boolean canEditImmediately(EventObject event) {
        return true;
    }
}
