// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;

import java.awt.Dimension;
import java.util.LinkedList;
import java.util.Properties;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JComponent;

import com.bbn.openmap.util.PropUtils;

import fr.unicaen.openmap.gui.dnd.MovableBox;

public class LayersBox extends MovableBox {

    public static String className = "fr.unicaen.openmap.gui.LayersBox";
    LinkedList<JComponent> children = new LinkedList<JComponent>();
    protected LayersPanelTree layersPanel;

    public LayersBox() {

        super(BoxLayout.Y_AXIS, "Lay", "Layers", ThemaMapPanel.transferHandler);
        type = BoxLayout.Y_AXIS;
        setName(i18n.get(this, "layers", "Layers"));
        setNameTab(i18n.get(this, "layers", "Layers"));
        preferredExternSize = new Dimension(250, 500);
        setPropertyPrefix("layersbox");
        layersPanel = new LayersPanelTree();
        layersPanel.setPropertyPrefix("LayersPanel");
        layersPanel.setBorder(BorderFactory.createEmptyBorder(5, 0, 0, 0));
        children.add(layersPanel);
        add(layersPanel);
    }

    @Override
    public void findAndInit(Object someObj) {
        if (someObj instanceof DisplayMenu) {
            DisplayMenu menu = (DisplayMenu) someObj;
            setMenuItem(menu.getLayersMenuItem());
            //menu.getConfigurationMenuItem().setCheckSelected(showConfigurationPanel);
        }
    }

    @Override
    public void setProperties(String prefix, Properties props) {
        prefix = PropUtils.getScopedPropertyPrefix(prefix);
        
    }

    public LayersPanelTree getLayersPanel() {
        return layersPanel;
    }

    public LinkedList<JComponent> getChildren() {
        return children;
    }
}
