// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionListener;
import javax.swing.DefaultListModel;


/**
 * JList useful for list of column names that can change
 */ 
public class RefreshableJList extends JList {

    public RefreshableJList(ListSelectionListener listSelectionListener, String[] names) {
	addListSelectionListener(listSelectionListener);
	setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	setModel(new DefaultListModel());
	init(names);
    }

    public void init(String[] names) {
	java.util.List<ListSelectionListener> actionListeners = new java.util.ArrayList<ListSelectionListener>();
	try {
	    for (ListSelectionListener al : this.getListSelectionListeners()) {
		this.removeListSelectionListener(al);
		actionListeners.add(al);
	    }
	    DefaultListModel model = (DefaultListModel)getModel();
	    model.removeAllElements();
	    for(String s : names)
		model.addElement(s);
	    for (ListSelectionListener al : actionListeners)
		this.addListSelectionListener(al);
	} catch (NullPointerException ex) {
	    System.err.println("Data Column Name List is unavailable");
	} catch (java.lang.ArrayIndexOutOfBoundsException ofb) {
	    System.err.println("Empty Data Column Name List");
	}
	updateUI();
    }
}
