// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui;
import java.awt.event.ActionListener;
import javax.swing.JComboBox;

/**
 * ComboBox useful for list of column names that can change
 */ 
public class RefreshableStringComboBox extends JComboBox {

    private ActionListener actionListener;
    public RefreshableStringComboBox(ActionListener actionListener, String[] names, String selectedName) {
	this.actionListener = actionListener;
	init(names, selectedName);
    }

    public void init(String[] names, String selectedName) {
	try {
	    for(ActionListener al : this.getActionListeners()){
		this.removeActionListener(al);
	    }
	    this.removeAllItems();
	    for(String s : names)
		this.addItem(s);
	    if(selectedName !=null && !"".equals(selectedName)){
		int index = 0;
		for (; index < names.length; index++)
		    if (names[index].equals(selectedName)) 
			break;
		if (index >= names.length)
		    index = -1;
		setSelectedIndex(index);
	    } 
	    this.addActionListener(actionListener);
		
	} catch (NullPointerException ex) {
	    System.err.println("Data Column Name List is unavailable");
	} catch (java.lang.ArrayIndexOutOfBoundsException ofb) {
	    System.err.println("Empty Data Column Name List");
	}
    }
	
}
