// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.JFrame;

/**
 *
 * @author jchauvea
 */
public class SplashScreen {

    protected JFrame splash;

    public SplashScreen(){
        splash = new JFrame();
        splash.setAlwaysOnTop(true);
        splash.setUndecorated(true);
        //frame.setDefaultLookAndFeelDecorated(false);
		TransparentBackground bg = new TransparentBackground(splash);
        bg.setLayout(null);
        bg.setBorder(null);
        SplashScreenPanel spc = new SplashScreenPanel("splashScreen.png");
        spc.setBorder(null);
        spc.setOpaque(false);
        bg.add(spc);
		splash.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		splash.getContentPane().add(bg);
		//frame.setLocation(500, 500);
        splash.pack();
        Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
        splash.setSize(650,471);
        //spc.setLocation((screen.width - spc.getSize().width)/2,(screen.height - spc.getSize().height)/2);
        splash.setLocation((screen.width - splash.getSize().width)/2,(screen.height - splash.getSize().height)/2);
        //frame.setLocationRelativeTo(null);
    }

    public void show(){
        splash.setVisible(true);
    }


    public void close(){
        splash.dispose();
    }

}
