// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.gui;

import fr.unicaen.openmap.util.Util;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 *
 * @author jchauvea
 */
public class SplashScreenPanel extends JPanel{

    private ImageIcon imageIcon;

    public final static int Width = 650;
    public final static int Height = 477;

    public SplashScreenPanel(String imageFile){
        imageIcon = Util.loadIcon(imageFile);
        setSize(new Dimension(imageIcon.getIconWidth() - 2, imageIcon.getIconHeight()));
        //setAlwaysOnTop(true);
        //setUndecorated(true);
        setBackground(new Color(0,0,0,255));
        setVisible(true);
    }

    public void paint(Graphics g) {
        g.drawImage(imageIcon.getImage(), 0, 0, null);
  }
}
