// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.component;

import java.awt.Component;

import java.awt.event.MouseAdapter;

import java.awt.event.MouseEvent;

import javax.swing.JCheckBox;

import javax.swing.JFrame;

import javax.swing.JList;

import javax.swing.JScrollPane;

import javax.swing.ListCellRenderer;

import javax.swing.ListSelectionModel;

public class CheckList

{

	public static void main(String args[])

	{

		JFrame frame = new JFrame();

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// Create a list containing CheckListItem's

		JList list = new JList(new CheckListItem[] {

		new CheckListItem("apple"),

		new CheckListItem("orange"),

		new CheckListItem("mango"),

		new CheckListItem("paw paw"),

		new CheckListItem("banana") });

		// Use a CheckListRenderer (see below)

		// to renderer list cells

		list.setCellRenderer(new CheckListRenderer());

		list.setSelectionMode(

		ListSelectionModel.SINGLE_SELECTION);

		// Add a mouse listener to handle changing selection

		list.addMouseListener(new MouseAdapter()

		{

			public void mouseClicked(MouseEvent event)

			{

				JList list = (JList) event.getSource();

				// Get index of item clicked

				int index = list.locationToIndex(event.getPoint());

				CheckListItem item = (CheckListItem)

				list.getModel().getElementAt(index);

				// Toggle selected state

				item.setSelected(!item.isSelected());

				// Repaint cell

				list.repaint(list.getCellBounds(index, index));

			}

		});

		frame.getContentPane().add(new JScrollPane(list));

		frame.pack();

		frame.setVisible(true);

	}

}

// Represents items in the list that can be selected


// Handles rendering cells in the list using a check box

