// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.component;

import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 *
 * @author jchauvea
 */
public class ScrollableTextArea extends JPanel{

    private JTextArea textArea;

    public ScrollableTextArea(Dimension dim, int r, int c){
        setLayout(new BorderLayout());
        setPreferredSize(dim);
        textArea = new JTextArea(r, c);
        JScrollPane sc = new JScrollPane(textArea);
        add(sc, BorderLayout.CENTER);
    }


    public void append(String text){
        textArea.append(text);
    }

    public void setText(String s){
        textArea.setText(s);
    }

    public String getText(){
        return textArea.getText();
    }

    public void setCaretPosition(int index){
        textArea.setCaretPosition(index);
    }

    public int getCaretPosition(){
        return textArea.getCaretPosition();
    }

    public void insert(String text, int index){
        textArea.insert(text, index);
    }

    public JTextArea getTextArea(){
        return textArea;
    }

}
