// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.dnd;

import java.awt.Cursor;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JComponent;
import javax.swing.JLabel;

/**
 * 
 * @author jchauvea
 *
 */
public class DragArea extends DndLabel implements MouseListener, MouseMotionListener {

    protected MovableBox box;

    public DragArea(String title, MovableBox box, DndTransferHandler handler,
            MovableBoxesContainer boxesContainer) {
        super(title, JLabel.CENTER);
        this.box = box;
        this.boxesContainer = boxesContainer;
        setTransferHandler(handler);
        addMouseListener(this);
        addMouseMotionListener(this);
    }

    public MovableBox getBox() {
        return box;
    }

    public void setBox(MovableBox box) {
        this.box = box;
    }

    public void mouseClicked(MouseEvent arg0) {
        // TODO Auto-generated method stub
    }

    public void mouseEntered(MouseEvent arg0) {
        setCursor(new Cursor(Cursor.HAND_CURSOR));

    }

    public void mouseExited(MouseEvent arg0) {
        setCursor(new Cursor(Cursor.DEFAULT_CURSOR));

    }

    public void mousePressed(MouseEvent arg0) {
        // TODO Auto-generated method stub
    }

    public void mouseReleased(MouseEvent arg0) {
        // TODO Auto-generated method stub
    }

    public void mouseDragged(MouseEvent e) {
        JComponent jc = (JComponent) e.getSource();
        DndTransferHandler th = (DndTransferHandler) jc.getTransferHandler();
        th.exportAsDrag(jc, e, DndTransferHandler.COPY);

    }

    public void mouseMoved(MouseEvent arg0) {
        // TODO Auto-generated method stub
    }
}
