// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.dnd;

import java.awt.Dimension;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JTabbedPane;

import fr.unicaen.openmap.layer.dataDisplayLayer.gui.SimplePalette;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;

public class DropTabArea extends DropArea{

	//public TabDropArea(DndTransferHandler handler, MovableBoxesContainer boxesContainer) {
	//	super(handler, boxesContainer);
		
		// TODO Auto-generated constructor stub
	//}
	protected JTabbedPane tabbed;
	
	public DropTabArea(DndTransferHandler handler, JTabbedPane tabbed){
		super(handler, null);
		this.tabbed = tabbed;
		setPreferredSize(DEFAULT_DIMENSION);
		setBorder(null);
	}
	
	@Override
	public void receive(DragArea source){

		
		source.getBox().showDragLabel(true);
		if(source.getBox().isTabMode()){
			source.getBox().setTabMode(false);
			source.getBox().detachFromTabbed();
		}
		
		MovableBoxesContainer receiverContainer = new MovableBoxesContainer(BoxLayout.Y_AXIS);
		MovableBoxesContainer sourceContainer = source.getBoxesContainer();
		

		source.getBox().getParentBoxContainer().removeElement(source.getBox());
		
		if(source.getBox().isExternalized() && !source.getBoxesContainer().containsBoxes())
			source.getBox().killParent();
		
		source.getBox().setParentBoxContainer(receiverContainer);
		
		//int indexReceiver = receiverContainer.getElementIndex(this);
		receiverContainer.addElement(source.getBox());
		//if(indexReceiver == 0){
		//	receiverContainer.addElement(source.getBox(), indexReceiver + 1);
		//}
		//else{
		//	receiverContainer.addElement(source.getBox(), indexReceiver);
		//}

		receiverContainer.updateGUI();
		sourceContainer.updateGUI();
		//}
		
		if(source.getBox().getParentFrame() != null){
			String title = source.getBox().getParentFrame().getTitle();
			source.getBox().getParentFrame().setTitle(title.replaceAll(source.getText(), ""));
		}
		
		if(getParentFrame()!=null){
			getParentFrame().setTitle(getParentFrame().getTitle()+" "+source.getText());
			source.getBox().setParentFrame(getParentFrame());
		}
		
		
		//source.setBoxesContainer(receiverContainer);
		
		source.getBox().setExternalized(false);
		receiverContainer.updateUI();
		sourceContainer.updateUI();
		sourceContainer.updateGUI();
		
		
		
		MovableBox m = source.getBox();
		m.setTabMode(true);
		m.showDragLabel(false);
		m.withPadding(false);
		//source.getBoxesContainer().removeElement(m);
		source.getBoxesContainer().updateGUI();
		tabbed.insertTab(source.getText(), null, receiverContainer, "", tabbed.getTabCount() - 1);
		m.setTabbed(tabbed);
		m.showAt(tabbed.getTabCount() - 2);
		
		tabbed.setVisible(false);
		tabbed.setVisible(true); 
		for(int i = 0; i <= tabbed.getTabCount() - 2; i++){
			tabbed.setSelectedIndex(i);
		}
		tabbed.updateUI();
		SimplePalette.customTabbedPaneUI(tabbed, tabbed.getTabCount() - 1);
		//ThematicDataDisplayLayer.tdaIndex = tabbed.getTabCount() - 1;
		//tabbed.setUI(ThematicDataDisplayLayer.TABBED_UI);


	}
	
	public void hover(Dimension dim){
		//setBackground(Color.RED);
		setPreferredSize(new Dimension(100,10));
		setMaximumSize(new Dimension(100,10));
		setBorder(BorderFactory.createLineBorder(BORDER_COLOR));
		updateUI();
	}
	public void unhover(){
		//setBackground(Color.LIGHT_GRAY);
		setPreferredSize(DEFAULT_DIMENSION);
		setMaximumSize(DEFAULT_DIMENSION);
		setBorder(null);
		updateUI();
	}

}
