// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.dnd;

import java.awt.Dimension;

import javax.swing.JFrame;

public class VerticalDropArea extends DropArea{

	public final static Dimension DEFAULT_DIMENSION = new Dimension(5,100);
	public final static Dimension DEFAULT_MAX_DIMENSION = new Dimension(5,1000);
	
	public VerticalDropArea(DndTransferHandler handler, MovableBoxesContainer boxesContainer) {
		super(handler, boxesContainer);
		setMinimumSize(DEFAULT_DIMENSION);
		setMaximumSize(DEFAULT_MAX_DIMENSION);


	}
	public VerticalDropArea(DndTransferHandler handler, MovableBoxesContainer boxesContainer, JFrame parentFrame){
		super(handler, boxesContainer, parentFrame);
		setPreferredSize(new Dimension(5,100));
		setMaximumSize(new Dimension(5,100));
		setMinimumSize(new Dimension(5,100));
	}
	
	public void unhover(){
		//setBackground(Color.LIGHT_GRAY);
		setPreferredSize(DEFAULT_DIMENSION);
		setMaximumSize(DEFAULT_MAX_DIMENSION);
		setBorder(DEFAULT_BORDER);
		updateUI();
	}

}
