// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.gui.menu;

import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.awt.geom.Point2D;
import java.beans.beancontext.*;
import java.net.MalformedURLException;
import javax.swing.JOptionPane;
import javax.swing.JFileChooser;

import com.bbn.openmap.*;
import com.bbn.openmap.gui.menu.MapHandlerMenuItem;
import com.bbn.openmap.util.Debug;
import com.bbn.openmap.Environment;
import com.bbn.openmap.proj.Projection;
import com.bbn.openmap.proj.ProjectionFactory;
import com.bbn.openmap.proj.coords.LatLonPoint;

import fr.unicaen.openmap.AtlasLayerHandler;
import fr.unicaen.openmap.gui.LayersPanelTree;
import fr.unicaen.openmap.gui.ThemaMapFileChooserManager;
import fr.unicaen.openmap.gui.ThemaMapPanelsManager;
import fr.unicaen.openmap.layer.utils.LayerLoader;
import fr.unicaen.openmap.util.TooManyLegendException;


/**
 *
 */
public class LoadAtlasPathMenuItem extends MapHandlerMenuItem implements
        ActionListener {

    private String titleString;
    protected ThemaMapPanelsManager tmpm;

    public LoadAtlasPathMenuItem(String initString) {
        super(initString);
        titleString = initString;
        addActionListener(this);
    }

    @Override
	public void findAndInit(Object someObj) {
        super.findAndInit(someObj);
        if (someObj instanceof ThemaMapPanelsManager) {
            tmpm = (ThemaMapPanelsManager) someObj;
            return;
        }
    }

    public void actionPerformed(ActionEvent ae) {
	// should launch a file chooser, but this is easier:
	ThemaMapFileChooserManager.dataLoadFileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	String path = ThemaMapFileChooserManager.dataLoadDialog("Atlas", null);
	if (path == null)
	    return;
	LayersPanelTree panel = tmpm.getLayersPanel(); 
	panel.setAtlasPath(path);
    }

}
