// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer;

import java.util.Properties;

import com.bbn.openmap.util.PropUtils;


import fr.unicaen.openmap.layer.dataDisplayLayer.SimpleDataDisplayLayer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import fr.unicaen.openmap.dataStorage.DataStorage;
import fr.unicaen.openmap.util.Util;

/** 
 *
 * @author Jacques.Madelaine@unicaen.fr
 */
public class QualitativeAnalysisLayer extends ThematicDataDisplayLayer {
    
    public Properties getPropertyInfo(Properties list) {
        PropUtils.setI18NPropertyInfo(i18n, //I18N
                list, //properties
                SimpleDataDisplayLayer.class, //class to set for
                DS_GLOBAL_CONFIGURATION_PROPERTY_STRING, //property Name
                DS_GLOBAL_CONFIGURATION_PROPERTY_STRING, //label
                DS_GLOBAL_CONFIGURATION_PROPERTY_STRING, //tooltip
                "fr.unicaen.openmap.util.propertyEditor.QualitativeAnalysisPropertyEditor");

        list.put(initPropertiesProperty, DS_GLOBAL_CONFIGURATION_PROPERTY_STRING);

	System.out.println("## QualitativeAnalysisLayer.getPropertyInfo()"+ list);
	return list;
    }
  public void setProperties(String prefix, Properties properties) {
        super.setProperties(prefix, properties);
	String ds_global = properties.getProperty(prefix + "." + DS_GLOBAL_CONFIGURATION_PROPERTY_STRING);
	System.out.println("##ds_global:"+ ds_global);
	if (ds_global == null || "".equals(ds_global))
	    properties.put(prefix + "." + DS_GLOBAL_CONFIGURATION_PROPERTY_STRING,
			   ".dataStorageClass=fr.unicaen.openmap.dataStorage.QualitativeAnalysisDataStorage; .maxIterations=10000; .printSteps=false; .distance=170.0; .layerAndThematicName=Monde,visu_a1; .modeDifference=2; .autoStop=true; .difference=1.0;");
	System.out.println("## properties:"+ properties);
  }
}

