// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.layer.chartLayer.chart;

import fr.unicaen.openmap.dataStorage.DataObject;
import fr.unicaen.openmap.dataStorage.DataStorageIterator;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import java.awt.image.BufferedImage;
import javax.swing.JComponent;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartPanel;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;

/**
 *
 * @author jchauvea
 */
public class BarChart extends Chart{

    private DefaultCategoryDataset dataset;

    public BarChart(DataStorageIterator dsi, String name, String xName, String yName, String[] categories, String[] series){
        super(dsi, name, xName, yName, categories, series);
    }

    @Override
    protected void buildDataSet(DataStorageIterator dsi) {
        dataset = new DefaultCategoryDataset();
        dsi.reset();
        while(dsi.hasNext()){
            DataObject dataObj = dsi.next();
//            String type = (String)dataObj.getData(serieColumn);
//            for(String s : typeColunms){
//                Double d = Double.parseDouble(dataObj.getData(s).toString());
//                dataset.setValue(d, type, s);
//            }
        }

    }

    @Override
    public BufferedImage getImage(int w, int h) {
        JFreeChart chart = ChartFactory.createBarChart(name, xName, yName, dataset,
                PlotOrientation.VERTICAL, true, true, true);
        return chart.createBufferedImage(w, h);
    }

    @Override
    public JFreeChart getJFreeChart() {
        return ChartFactory.createBarChart(name, xName, yName, dataset,
                PlotOrientation.VERTICAL, true, true, true);
    }

}
