// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.layer.chartLayer.chart;

import fr.unicaen.openmap.dataStorage.DataStorageIterator;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.ColorScale;
import java.awt.image.BufferedImage;
import javax.swing.JComponent;
import org.jfree.chart.JFreeChart;

/**
 *
 * @author jchauvea
 */
public abstract class Chart {


    public enum ChartType {

        BAR,
        XY
    }

    protected int nbSeries;
    protected String name;
    protected String xName;
    protected String yName;
    protected String[] categories;
    protected String[] series;
    //protected ColorScale colorScale;

    public Chart(DataStorageIterator dsi,String name, String xName, String yName, String[] categories, String[] series){
        this.name = name;
        this.xName = xName;
        this.yName = yName;
        this.categories = categories;
        this.series = series;
        //this.nbSeries = cs.getColorNumber();
        buildDataSet(dsi);
    }

    protected abstract void buildDataSet(DataStorageIterator dsi);

    public abstract BufferedImage getImage(int w, int h);

    public abstract JFreeChart getJFreeChart();

//    public int getNBTypes(){
//        return typeColunms.length;
//    }

}
