// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.chartLayer.chart;

import fr.unicaen.openmap.dataStorage.DataStorageIterator;

/**
 *
 * @author jchauvea
 */
public class ThemaMapChartFactory {


    public static Chart buildChart(Chart.ChartType c, DataStorageIterator dsi, String name, String xName, String yName, String[] categories, String[] series) {
        switch (c) {
            case BAR:
                return buildBarChart(dsi, name, xName, yName, categories, series);
        }
        return null;

    }

    public static Chart buildBarChart(DataStorageIterator dsi, String name, String xName, String yName,  String[] categories, String[] series) {

        return new BarChart(dsi, name, xName, yName, categories, series);
    }

    public static Chart buildXYChart(DataStorageIterator dsi, String name, String xName, String yName,  String[] categories, String[] series) {

        return new XYChart(dsi, name, xName, yName, categories, series);
    }
}
