// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.dataDisplayLayer.gui;
import com.bbn.openmap.BasicI18n;
import com.bbn.openmap.I18n;
import com.bbn.openmap.util.Debug;
import fr.unicaen.openmap.dataStorage.gui.SelectionStoragePanel;
import fr.unicaen.openmap.util.Util;
import java.awt.*;
import java.util.Locale;
import javax.swing.*;


/**
 * This class geive use the ability to manage spécificity of SelectionDataStorage and InteractiveDisplayDataLayer.
 */

public class SelectionPalette extends SimplePalette  {
    private SelectionStoragePanel datas = null;
    
    /**
     * Creates a palette with two tools : request panel and graphics panel.
     * @param left Component layed in first
     * @param graphicsPanel Component to have colors choice
     */
    public SelectionPalette(Component left, GraphicsPanel graphicsPanel, SelectionStoragePanel storagePanel) {
        super(left,graphicsPanel,storagePanel);
        datas=storagePanel;
    }
    
    /**
     * return the storagePanel. This give us the ability  to manage interactions between layer and Gui palette.
     **/
    public SelectionStoragePanel getDataPanel(){
        return  datas;
    }
}
