// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import com.bbn.openmap.Environment;
import com.bbn.openmap.omGraphics.OMColorChooser;
import fr.unicaen.openmap.gui.ThemaMapColorChooser;
import java.awt.Color;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;

/**
 *
 * @author jchauvea
 */
public class ColorScaleButton extends JButton implements ActionListener{

    private ColorScalePanel scalePanel;
    private int position;

    public ColorScaleButton(ColorScalePanel scalePanel, int position){
        super();
        this.scalePanel = scalePanel;
        this.position = position;
        setFont(new Font("Arial", Font.PLAIN, 8));
        addActionListener(this);
    }

    public void actionPerformed(ActionEvent evt) {
	Color newColor = ThemaMapColorChooser.showDialog(
                this,
                Environment.getI18n().get(ColorScalePanel.class, "colorChooser", "Choose a color..."),
                getBackground());
        if (newColor != null) {
                setBackground(newColor);
                scalePanel.updateColorScaleAt(position, newColor);
            }
    }

    public int getPosition() { return position; }

}
