// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JComboBox;
import fr.unicaen.openmap.util.gui.ComponentSizer;

import  fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Visu;
import  fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.MutableString;
import fr.unicaen.openmap.dataStorage.DataStorageIterator;

/**
 *
 * @author Jacques.Madelaine@unicaen.fr
 */
public class DataColumnNameList extends JComboBox{

    private Visu visu;
    private MutableString columnName;

    public DataColumnNameList(Visu visu, MutableString columnName) {
	super();
	this.visu = visu;
	this.columnName = columnName;
	init();
    }

    public void init() {
	
        DataStorageIterator dsi = visu.getLayer().getDataStorageIterator();

	for (ActionListener a : getActionListeners()) {
	    removeActionListener(a);
	}
	removeAllItems();
	for (String item : dsi.getDataColumnNames()) {
	    addItem(item);
	}
    
        // System.out.println("DATA COLUMN NAME" + getDataColumnName());
        if (!"".equals(columnName.get()) && columnName.get() != null) {
            setSelectedIndex(dsi.getIndexForColumnName(columnName.get()));
        } else {
	    setSelectedIndex(-1);
	}

        addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                try {
                    int index = ((JComboBox) e.getSource()).getSelectedIndex();
                    columnName.set(visu.getLayer().getDataStorageIterator().getRealColumnName(index));
		    visu.refresh();
                } catch (ArrayIndexOutOfBoundsException ex) {
                }
            }
        });
        ComponentSizer.fixComponentSize(this, new Dimension(120, 20));
    }
    
}
