// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import java.util.HashMap;
import java.util.Map;

/**
 *Manage thematic collapsable legend panels. Used when legend's GUI is rebuilt to open/close
 * panels
 * @author jchauvea
 */
public class LegendGUIManager implements CollapsablePanelsListener{


    public enum state { open , close };

    private Map<String, state> stateLegendPanels;

    public LegendGUIManager(){
        stateLegendPanels = new HashMap<String, state>();
    }
    
    public void panelOpened(String tvName){
        stateLegendPanels.put(tvName, state.open);
    }

    public void panelClosed(String tvName){
        stateLegendPanels.put(tvName, state.close);
    }

    public boolean isOpened(String tvName){
        return (stateLegendPanels.get(tvName) == null ||stateLegendPanels.get(tvName) == state.open);
    }


}
