// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui;

import fr.unicaen.openmap.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.awt.Component;
import java.awt.event.ActionEvent;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 * @author jchauvea
 */
public class ThematicPopupMenu extends LayerPopupMenu {

    public ThematicPopupMenu(LayersTree tree, boolean v) {
        super(tree, v);
        //add(remove);
        up.setText(
                i18n.get(this, "moveThematicUpOne", "up"));
        down.setText(
                i18n.get(this, "moveThematicDownOne", "down"));
        remove.setText(
                i18n.get(this, "removeThematic", "remove"));
    }

    public void show(Component cp, int x, int y, DefaultMutableTreeNode node) {
        super.show(cp, x, y);
        currentNode = node.getUserObject();
        Thematic th = ((Thematic) currentNode);
        visible.removeActionListener(this);
        visible.setSelected(th.isVisible());
        visible.addActionListener(this);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        Object source = e.getSource();
        Thematic th = ((Thematic) currentNode);
        if (source == visible) {
            th.setVisible(visible.isSelected());
            th.getLayer().refreshGraphics();
            return;
        }

        if (source == up) {
            tree.moveUpSelectedNode();
            //th.getLayer().moveUpThematicVisu(th);

            return;
        }

        if (source == down) {
            tree.moveDownSelectedNode();
            //th.getLayer().moveDownThematicVisu(th);
            return;
        }

        if (source == rename) {
            String name = JOptionPane.showInputDialog(this,
                    i18n.get(LayerPopupMenu.class,"newname","New name"),
                    i18n.get(LayerPopupMenu.class,"visualisation","Visualisation")+ " "+th.getName(),
                    JOptionPane.QUESTION_MESSAGE);
            if(!name.equals("")){
                th.setName(name);
                tree.updateUI();
            }
            return;
        }

        if (source == remove) {
            /*int rep = JOptionPane.showConfirmDialog(this,
            i18n.get(VisuTabComponent.class, "closeConfirmation", I18n.TOOLTIP, "Do you want to delete the {0} type visu named {1}?", selected.getTV().getTypeName(), selected.getTV().getName()),
            i18n.get(this, "closeConfirmation", "Confirmation"), JOptionPane.YES_NO_OPTION);*/
            int rep = JOptionPane.showConfirmDialog(this, i18n.get(ThematicPopupMenu.class, "confirmation","Really remove?"), "Confirmation", JOptionPane.YES_NO_OPTION);
            if (rep == JOptionPane.YES_OPTION) {
                Thematic tv = (Thematic) currentNode;
                tv.getLayer().deleteThematicVisu(tv);
                tv.getLayer().refreshGraphics();
                //tree.removeSelectedNode();
            }
        }
    }
}
