// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import java.util.Hashtable;

public class ArrowHead {

    public enum ArrowHeadType {

        NOHEAD(0, 1, 0, "NoHead", 0),
        SHARP(1, 1, 1, "Sharp", 1),
        HEAD(3, 2, 2, "Head", 2),
        FLATHEAD(2, 3, 2, "FlatHead",3),
        DIAMOND(2, 3, 3, "Diamond",4);

        protected int length;
        protected int width;
        protected int depth;
        protected int thickness;
        protected int num;
        protected String name;

        ArrowHeadType(int l, int w, int d, String n, int num) {
            this.length = l;
            this.width = w;
            this.depth = d;
            this.thickness = 0;
            this.name = n;
            this.num = num;
        }

        public String getName() {
            return name;
        }

        public int getLength() {
            return length;
        }

        public int getWidth() {
            return width;
        }

        public int getDepth() {
            return depth;
        }

        public int getThickness() {
            return thickness;
        }

        public int getNum(){
            return num;
        }
    }
//    private int length;
//    private int width;
//    private int depth;
//    private int thickness;
//    /**
//     * The name of the model as it can appear in a Palette
//     */
//    private String name;
//
//    // public enum Arrows {Sharp, NoHead, Head, ThinHead, FlatHead, Diamond};
//    /**
//     * ctor for arrow head models
//     */
//    public ArrowHead(int l, int w, int d, String n) {
//        length = l;
//        width = w;
//        depth = d;
//        thickness = 0;
//        name = n;
//    }
//
//    public ArrowHead(int l, int w, int d) {
//        this(l, w, d, "Custom");
//    }
//
//    /**
//     * Constructs an actual arrowhead from a model for a given thickness
//     */
//    public ArrowHead(ArrowHead model, int thickness) {
//        length = model.length * thickness;
//        width = model.width * thickness;
//        depth = model.depth * thickness;
//        name = model.name;
//        this.thickness = thickness;
//    }
//
//    public String getName() {
//        return name;
//    }
//
//    public int getLength() {
//        return length;
//    }
//
//    public int getWidth() {
//        return width;
//    }
//
//    public int getDepth() {
//        return depth;
//    }
//
//    public int getThickness() {
//        return thickness;
//    }
//    private static Hashtable<String, ArrowHead> arrowHeadModels;
//
    public static ArrowHeadType getModel(String modelName) {
        for(ArrowHeadType a: ArrowHeadType.values()){
            if(a.getName().equals(modelName))
                return a;
        }
        return ArrowHead.ArrowHeadType.NOHEAD;
    }

        public static ArrowHeadType getModel(int num) {
        for(ArrowHeadType a: ArrowHeadType.values()){
            if(a.getNum() == num)
                return a;
        }
        return ArrowHead.ArrowHeadType.NOHEAD;
    }
//
//    public static ArrowHead getModelAt(int index) {
//        if (arrowHeadModels == null) {
//            initArrowHeadModels();
//        }
//        return (ArrowHead) arrowHeadModels.get(index);
//    }
//
//    /**
//     * Arrowhead models needed only to be defined here
//     */
//    private static void initArrowHeadModels() {
//        arrowHeadModels = new Hashtable<String, ArrowHead>(10);
//
//        // *** Caution: if you add a model here, add it in the method getArrowHeadModelsNames()
//
//        arrowHeadModels.put("Sharp", new ArrowHead(1, 1, 1, "Sharp"));
//        arrowHeadModels.put("NoHead", new ArrowHead(0, 1, 0, "NoHead"));
//        arrowHeadModels.put("Head", new ArrowHead(3, 2, 2, "Head"));
//        //arrowHeadModels.put("ThinHead",  new ArrowHead(2F, 3F, 1F,    "ThinHead"));
//        arrowHeadModels.put("FlatHead", new ArrowHead(2, 3, 2, "FlatHead"));
//        arrowHeadModels.put("Diamond", new ArrowHead(2, 3, 3, "Diamond"));
//
//    }
//    /**
//     * Table of arrowhead models names automatically extraceted from
//     * the map arrowHeadModels
//     */
//    private static String[] arrowHeadModelsNames = {"Sharp", "NoHead", "Head"/*,"ThinHead",*/, "FlatHead", "Diamond"};
//
//    public static String[] getArrowHeadModelsNames() {
//        if (arrowHeadModelsNames == null) {
//            // arrowHeadModelsNames = new String[arrowHeadModels.size()];
//            //int i = 0;
//            // using the Enumeration change the order !-(
//            // for (Enumeration e = arrowHeadModels.keys(); e.hasMoreElements() ; i++)
//            //	 arrowHeadModelsNames[i] = (String)e.nextElement();
//            // }
//            // arrowHeadModelsNames[i++] = "Sharp"   ;
//            // arrowHeadModelsNames[i++] = "NoHead"  ;
//            // arrowHeadModelsNames[i++] = "Head"    ;
//            // arrowHeadModelsNames[i++] = "ThinHead";
//            //  arrowHeadModelsNames[i++] = "FlatHead";
//            // arrowHeadModelsNames[i++] = "Diamond";
//        }
//
//        return arrowHeadModelsNames;
//    }
}
