// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import java.awt.Color;
import com.bbn.openmap.omGraphics.*;
import com.bbn.openmap.MapBean;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.*;

public abstract class OMControlAngle extends OMControlPoint {
	
    public OMControlAngle(int x, int y, int radius, MapBean mb) {
	super(x, y, radius, mb);
    }   
    
    public OMControlAngle(int x, int y, int radius, Color c, MapBean mb) {
	super(x, y, radius, c, mb);
    }
	
    public OMControlAngle(int x, int y, int radius, Color c, Color sc, MapBean mb) {
	super(x, y, radius, c, sc, mb);
    }

    protected void setXYs() {
	setXs(new int[] { 
	    x0,          
	    x0-3*radius, 
	    x0-3*radius, 
	    x0+radius,   
	    x0+radius,
	    x0 });
	setYs(new int[] { 
	    y0,
	    y0,
	    y0+radius,
	    y0+radius,
	    y0-3*radius,
	    y0-3*radius	});
    }

    public abstract int getCursor();
}

