// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import com.bbn.openmap.omGraphics.OMText;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Offsetable;
import java.awt.Font;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.Rectangle;
import java.awt.geom.Point2D;

/**
 *
 * @author jchauvea
 */
public class OMLabel extends OMOffsetable {

    private OMText omText;

    public OMLabel(Offsetable off, String id, double lat, double lon, int offX, int offY, String name, Font font, int align, double angle, boolean v, boolean l) {
	this(off, id, lat, lon, offX, offY, name, font, align, v, l);
	omText.setRotationAngle(angle);
    }

    public OMLabel(Offsetable off, String id, double lat, double lon, int offX, int offY, String name, Font font, int align, boolean v, boolean l) {
        super(off, id, lat, lon, offX, offY, v, l);
        omText = new OMText(lat, lon, offX, offY, name, font, align);
        add(omText);
        init(offX, offY);
    }

    public OMLabel(Offsetable off,String id, double lat, double lon, int offX, int offY, String name, Font font, int align, boolean v) {
        this(off, id, lat, lon, offX, offY, name, font, align, v, false);
    }

    public OMText getOMText(){return omText;}

    public int getHeight() {
	// Polygon p = omText.getPolyBounds();
        // Rectangle r = p.getBounds();
        // return (int) r.getWidth();
        // return (int) r.getHeight();
	return 0;
    }

    public int getWidth() {
	// Polygon p = omText.getPolyBounds();
        // Rectangle r = p.getBounds();
        // return (int) r.getWidth();
        // return (int) r.getHeight();
	return 0;
    }

//    public void setLocation(int x, int y){
//        //System.out.println("OMLABEL SET LOCATION "+x+";"+y);
//        omText.setX(x);
//        omText.setY(y);
//    }

    @Override
    public void translate(int x, int y){
        super.translate(x, y);
        omText.setX(getX());
        omText.setY(getY());
    }

//    @Override
//    public int getX() {
//        return omText.getX();
//    }
//
//    @Override
//    public int getY() {
//        return omText.getY();
//    }

}
