// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import com.bbn.openmap.omGraphics.OMPoint;
import com.bbn.openmap.proj.coords.LatLonPoint;
import java.awt.Color;
import java.awt.event.MouseEvent;

/**
 *Control point of OMOffsetable
 * @author dje
 */
public class OMOffsetableControlPoint extends OMPoint implements ThemaMapControlPoint{

    private OMOffsetable offsetable;
    public OMOffsetableControlPoint(double lat, double lon, OMOffsetable omf, int xOff, int yOff) {
        super(lat, lon, xOff, yOff);
        setFillPaint(Color.YELLOW);
        setSelectPaint(Color.RED);
        this.offsetable = omf;
        setSelected(false);
    }

    public void doActionPressed(MouseEvent e) {
        offsetable.startDrag();
    }

    public void doActionReleased(MouseEvent e) {
        offsetable.endDrag();
    }

    public void doActionDragged(MouseEvent e) {
        offsetable.updatePosition(e.getX(), e.getY());
    }

//    public void select() {
//        super.select();
//    }

    @Override
    public void setSelected(boolean bool) {
        setFillPaint(bool ? Color.RED : Color.YELLOW);
        super.setSelected(bool);
    }

}
