// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Offsetable;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
/**
 *
 * @author jacques.madelaine@unicaen.fr
 */
public abstract class OMOffsetableWithData extends OMOffsetable implements HaveWidthAndData  {


    public OMOffsetableWithData(Object data) {
	putData(data);
    }

    /**  Full Lat/Lon render type (no x/y offset is possible) */ 
    public OMOffsetableWithData(double lat, double lon, Object data) {
       super(lat, lon);
	putData(data);
   } 

    /** XY RENDER TYPE attached to a latlon point */
    public OMOffsetableWithData(Offsetable off, String id, double lat, double lon, int offX, int offY, boolean cpVisibility, boolean lineVisibility, Object data) {
	super(off, id, lat, lon, offX, offY, cpVisibility, lineVisibility);
	putData(data);
    }

    private void putData(Object data) {
        putAttribute(ThematicDataDisplayLayer.VALUE, data);
    }

    public Object getData() {
        return getAttribute(ThematicDataDisplayLayer.VALUE);
    }

    abstract public int getWidth();

}
