// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import fr.unicaen.openmap.omGraphics.DrawingAttributes;
import java.awt.Paint;

/**
 *Drawing Attributes for a thematic. It refreshs its thematic when line or fill
 * paint color has changed
 * @author dje
 */
public class ThematicDrawingAttributes extends DrawingAttributes {

    protected Thematic thematic;

    public ThematicDrawingAttributes(Thematic thematic, boolean bColorMenu, boolean bCapMenu, boolean bJointMenu, boolean bLinePaint, boolean bFillPaint) {
        this(thematic, bColorMenu, bCapMenu, bJointMenu, bLinePaint, bFillPaint, true);
    }

    public ThematicDrawingAttributes(Thematic thematic, boolean bColorMenu, boolean bCapMenu, boolean bJointMenu, boolean bLinePaint, boolean bFillPaint, boolean strokeAndDash) {
        super(bColorMenu, bCapMenu, bJointMenu, bLinePaint, bFillPaint, strokeAndDash);
        this.thematic = thematic;
    }

    @Override
    public void setFillPaint(Paint paint){
        super.setFillPaint(paint);
        thematic.drawingAttributesChanged();
    }

    @Override
    public void setLinePaint(Paint paint) {
        super.setLinePaint(paint);
        thematic.drawingAttributesChanged();
    }

    @Override
    public void setFilled(boolean b) {
        super.setFilled(b);
        thematic.drawingAttributesChanged();
    }

    @Override
    public void setStroke(java.awt.Stroke stroke) {
        super.setStroke(stroke);
        thematic.drawingAttributesChanged();
    }


}
