// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import com.bbn.openmap.util.PropUtils;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.util.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.ProportionalSymbol;
import java.awt.Paint;
import javax.swing.*;
import java.util.Properties;

public class OMResizeableColoredProportionalSymbolLegend extends OMResizeableFrame {

    public OMResizeableColoredProportionalSymbolLegend(Refreshable r, MouseControlPointsListener ml, int xAnchor, int yAnchor, Resizer resizer, MinMaxValues minMaxValues, ProportionalSymbol.type t, int nbEdges, double startAngle, int starCoef, String columnName, Paint  lineColor, Paint fillColor, ColorScale colorScale, String[] colorNames, String colorDataColumnName, String name) {
	super(r, ml, xAnchor, yAnchor, 0, 0, "", true, name); // we'll set width and height at the end of the ctor.
	init(resizer, minMaxValues, t, nbEdges, startAngle, starCoef, columnName, lineColor, fillColor, colorScale, colorNames, colorDataColumnName);
    }

    public void init(Resizer resizer, MinMaxValues minMaxValues, ProportionalSymbol.type t, int nbEdges, double startAngle, int starCoef, String columnName, Paint  lineColor, Paint fillColor, ColorScale colorScale, String[] colorNames, String colorDataColumnName) {

	this.clear();
	OMResizeableFrame rpl = t == ProportionalSymbol.type.DISC 
	    ? new OMResizeableDiscLegend
	    (refreshable, ml, 0, 0, resizer, minMaxValues, columnName, 
	     lineColor, fillColor, colorDataColumnName)
	    : new OMResizeableRegularPolygonLegend
	    (refreshable, ml, 0, 0, resizer, minMaxValues, nbEdges, startAngle,
	     starCoef, columnName, lineColor, fillColor, colorDataColumnName);
	OMResizeableFrame scl = 
	    new OMResizeableColorScaleLegend(refreshable, ml, 0, rpl.getHeight()+10, 
					     colorScale, colorNames, 
					     colorDataColumnName, colorDataColumnName);
	// scl.showBorder(false);
	int width = rpl.getWidth()>scl.getWidth()?rpl.getWidth():scl.getWidth();
	int height = rpl.getHeight()+scl.getHeight();
	this.add(rpl);
	this.add(scl);
	this.extendBorder(width, height+20);
    }

}
