// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import java.awt.Color;
import java.awt.Point;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.MouseControlPointsListener;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.ArrowHead;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.OMControlNPoint;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.OMControlPoint;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.OMFlow;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.Refreshable;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Flow;

public class OMResizeableFlow extends OMResizeableGraphic {

    private OMFlow omFlow;
    private Point anchor;
    private Point pEnd;
    public OMResizeableFlow(Refreshable r, MouseControlPointsListener ml, Flow flow, Point p1, Point p2,
			    ArrowHead.ArrowHeadType arrowStart, ArrowHead.ArrowHeadType arrowEnd, int size, 
			    java.awt.Paint fillColor, java.awt.Paint lineColor) {
	super(r, ml, "");  // empty name as we don't want a GUI for it.
	anchor = p1;
	pEnd = p2;
	omFlow = new OMFlow(flow, p1, p2, arrowStart, arrowEnd, size);
	omFlow.setFillPaint(fillColor);
	omFlow.setLinePaint(lineColor);
	//Point mid = new Point((int)(p1.getX() + p2.getX() / 2),(int)(p1.getY() + p2.getY() / 2));
	addOMControlPoint(new OMControlNPoint((int)p1.getX(),(int) p1.getY(), 
					      OMResizeableGraphic.OMControlPointRadius, 
					      Color.yellow, Color.red, refreshable.getMapBean()));
	add(omFlow);
    }


    public void extend(int dw, int dh) {
	// don't extend
    }


    public int getHeight() {
	// should take into account arrow heads
	return omFlow.getWidth()*3;
    }


    public int getWidth() {
	return OMResizeableFlowLegend.FLOW_SIZE;
    }

    @Override
	public int getXAnchor() {
	return (int)anchor.getX();
    }

    public int getYAnchor() {
	return (int)anchor.getY();
    }

    public void translate(int dx, int dy) {
	Point p1 = new Point(getXAnchor() + dx, getYAnchor() + dy);
	Point p2 = new Point((int)pEnd.getX() + dx, (int)pEnd.getY()  + dy);
	omFlow.setPStart(p1);
	omFlow.setPEnd(p2);
	anchor = p1;
	pEnd = p2;
	for(int i = 0; i < omControlPoints.size(); i++) 
	    ((OMControlPoint)omControlPoints.getOMGraphicAt(i)).translate(dx, dy);
		
    }

}
