// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import com.bbn.openmap.event.*;
import com.bbn.openmap.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import java.awt.Color;
import java.awt.event.*;
import javax.swing.*;
import java.awt.Dimension;

public class OMResizeableLine extends OMResizeableGraphic {
    private OMLine omLine;
    
    public OMResizeableLine(Refreshable refreshable, MouseControlPointsListener ml, int px1, int py1, int px2, int py2) {
	this(refreshable, ml, px1, py1, px2, py2, Color.black);
    }
    
    protected int [] linePts;
    public OMResizeableLine(Refreshable refreshable, MouseControlPointsListener ml, int px1, int py1, int px2, int py2, Color color) {
	super(refreshable, ml, "");  // empty name as we don't want a GUI for it.
	omLine = new OMLine(px1, py1, px2, py2);
	omLine.setLinePaint(color);
	linePts = omLine.getPts();
	addOMControlPoint(new OMControlNPoint(px1, py1, 
					      OMResizeableGraphic.OMControlPointRadius, 
					      Color.yellow, Color.red, refreshable.getMapBean()));
	add(omLine);
    }

    public void translate(int dx, int dy) {
	linePts[0] += dx; linePts[2] += dx; 
	linePts[1] += dy; linePts[3] += dy; 

	for(int i = 0; i < omControlPoints.size(); i++) 
	    ((OMControlPoint)omControlPoints.getOMGraphicAt(i)).translate(dx, dy);
    }

    public void extend(int dw, int dh) {}

    public int getXAnchor() { return linePts[0]; }
    public int getYAnchor() { return linePts[1]; }
    public int getWidth() { return Math.abs(linePts[2] - linePts[0]); }
    public int getHeight() { return Math.abs(linePts[3] - linePts[1]); }
    
}
