// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import com.bbn.openmap.omGraphics.*;
import com.bbn.openmap.proj.Projection;
import com.bbn.openmap.util.PropUtils;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;
import fr.unicaen.openmap.util.Colors;
import fr.unicaen.openmap.util.FontDialog;
import fr.unicaen.openmap.util.Util;
import fr.unicaen.openmap.util.gui.ComponentSizer;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.text.JTextComponent;
import javax.swing.plaf.basic.BasicButtonUI;
import java.awt.*;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.util.Properties;

public class OMResizeableMultiLineText extends OMResizeableText {

    public OMResizeableMultiLineText(Refreshable r, MouseControlPointsListener ml, int px1, int py1, String stuff) {
        super(r, ml, px1, py1, stuff, OMText.JUSTIFY_LEFT);
    }

    public OMResizeableMultiLineText(Refreshable r, MouseControlPointsListener ml, int px1, int py1, String stuff, int just) {
        super(r, ml, px1, py1, stuff, just, null);
    }

    public OMResizeableMultiLineText(Refreshable r, MouseControlPointsListener ml, int px1, int py1, String stuff, int just, String nameForGUI) {
        super(r, ml, px1, py1, stuff, just, nameForGUI, true);
    }

    public OMResizeableMultiLineText(Refreshable r, MouseControlPointsListener ml, int px1, int py1, String stuff, int just, String nameForGUI, boolean withControlPoints){
        super(r, ml, px1, py1, stuff, just, nameForGUI, withControlPoints, false);
    }

    public OMResizeableMultiLineText(Refreshable r, MouseControlPointsListener ml, int px1, int py1, String stuff, int just, String nameForGUI, boolean withControlPoints, boolean ra) {
        super(r, ml, px1, py1, stuff, just, nameForGUI, withControlPoints, ra);
    }

    public JComponent getGUI() {
	return getGUI(true);
    }

    /** takes end of line into account */
    protected void initWidthHeight() {
	String[] text = getText().split("[\n\r]");
	Rectangle2D rect = Util.getStringBounds(text[0], getFont());
	width = (int)(rect.getWidth()*1.1);
	height = (int)rect.getHeight();
	for (int i = 1; i < text.length; i++) {
	    rect = Util.getStringBounds(text[i], getFont());
	    if (width < (int)(rect.getWidth()*1.1))
		width = (int)(rect.getWidth()*1.1);
	    height += (int)rect.getHeight();
	}
    }

}
