// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend;

import com.bbn.openmap.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;
import fr.unicaen.openmap.util.FontDialog;
import fr.unicaen.openmap.util.Util;
import java.awt.event.*;
import javax.swing.*;

import java.awt.Dimension;
import java.awt.geom.Rectangle2D;

/** 
 * The only difference with OMResizeableText is in the GUI where the text is presented 
 * in a TexTArea allowing multilines text. 
 *
 * @deprecated see OMResizeableMultiLineText
 */
public class OMResizeableTextArea extends OMResizeableText {

    public OMResizeableTextArea(Refreshable r, MouseControlPointsListener ml, int px1, int py1, String stuff) {
	super(r, ml, px1, py1, stuff, OMText.JUSTIFY_CENTER);
    }

    public OMResizeableTextArea(Refreshable r, MouseControlPointsListener ml, int px1, int py1, String stuff, int just) { 
	super(r, ml, px1, py1, stuff, OMText.JUSTIFY_CENTER, null);
    }
	
    public OMResizeableTextArea(Refreshable r, MouseControlPointsListener ml, int px1, int py1, String stuff, int just, String nameForGUI) { 
	super(r, ml, px1, py1, stuff, just, nameForGUI);
    }

    /** takes end of line into account */
    protected void initWidthHeight() {
	String[] text = getText().split("[\n\r]");
	Rectangle2D rect = Util.getStringBounds(text[0], getFont());
	width = (int)(rect.getWidth()*1.1);
	height = (int)rect.getHeight();
	for (int i = 1; i < text.length; i++) {
	    rect = Util.getStringBounds(text[i], getFont());
	    if (width < (int)(rect.getWidth()*1.1))
		width = (int)(rect.getWidth()*1.1);
	    height += (int)rect.getHeight();
	}
    }

    public JComponent getGUI() {
	Box box = Box.createHorizontalBox();


	box.add(getToolGUI());

	JLabel lab = new JLabel(getName());
	lab.setPreferredSize(new Dimension(200,20));
	lab.setMaximumSize(new Dimension(200,20));
	box.add(lab);


	//box.add(Box.createHorizontalStrut(5)); 

	textComponent = new JTextArea(getText(), 5 , 10);
	textComponent.setMaximumSize(new Dimension(200,20));
	textComponent.setPreferredSize(new Dimension(200,20));
	JScrollPane sp = new JScrollPane(textComponent);
	sp.setMaximumSize(new Dimension(400,200));
	box.add(sp);

	final FontDialog fontDialog = new FontDialog(getFont(), getFontColor(), 0, 0.0);
	JButton fontButton = new JButton("", Util.loadIcon("visu/fonts.png"));
	fontButton.setPreferredSize(new Dimension(20, 20));
	fontButton.addActionListener(new ActionListener() {

		public void actionPerformed(ActionEvent event) {
		    fontDialog.setVisible(true);

		    if (!fontDialog.isCanceled()) {
			setFont(fontDialog.getSelectedFont());
			setLinePaint(fontDialog.getFontColor());
			textComponent.setForeground(fontDialog.getFontColor());
		    }
		}
	    });
	box.add(fontButton);

	JButton b = new JButton("Ok");
	b.addActionListener(new ActionListener() { 
		public void actionPerformed(ActionEvent e) {
		    setText(textComponent.getText());
		    refreshGraphics();
		}
	    });
	box.add(b);
	
	return box;
    }

    
}
