// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.util;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.AttributesColorScalePanel;
import fr.unicaen.openmap.util.gui.ComponentSizer;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author jchauvea
 */
public class AttributesPanel extends JPanel {

    //protected AttributesNames attributesNames;
    protected JComboBox combos[];
    protected Box boxCombos;
    protected JScrollPane scrollCombos;
    /**
     * Available data column names.
     */
    protected String[] availables;
    protected String[] selected;
    //protected Vector<String> defaultAvailable = new Vector<String>();
    protected int nbCombos;
    protected int nb;

    public AttributesPanel(String[] av, int nb) {
        //super(colorScale);
        //this.attributesNames = attributesNames;
        setLayout(new BorderLayout());
        availables = av;
        this.nb = nb;
        final JSpinner spinNbCombos = new JSpinner();
        spinNbCombos.addChangeListener(new ChangeListener() {

            public void stateChanged(ChangeEvent arg0) {
                AttributesPanel.this.nb = (Integer)spinNbCombos.getValue();
                updateNbCombos();
            }
        });
        spinNbCombos.setValue(nb);
        JLabel labNbCombos = new JLabel("Nombre");
        JPanel pTop = new JPanel();
        pTop.add(labNbCombos);
        pTop.add(spinNbCombos);
        add(pTop, BorderLayout.NORTH);
        updateNbCombos();
        add(scrollCombos, BorderLayout.CENTER);
    }

    private void updateNbCombos() {
        if (boxCombos == null) {
            boxCombos = Box.createVerticalBox();
            scrollCombos = new JScrollPane(boxCombos);
            //scrollCombos.setMaximumSize(new Dimension(200,100));
            ComponentSizer.fixComponentSize(scrollCombos, new Dimension(200,60));
            scrollCombos.setBorder(BorderFactory.createEmptyBorder());
            boxCombos.setBorder(BorderFactory.createEmptyBorder());
        } else {
            boxCombos.removeAll();
        }
        combos = new JComboBox[nb];
        for (int i = 0; i < nb; i++) {
            JComboBox cb = new JComboBox(availables);
            JPanel wrapTop = new JPanel(new BorderLayout());
            wrapTop.add(cb, BorderLayout.NORTH);
            boxCombos.add(wrapTop);
            combos[i] = cb;
            cb.addItemListener(new ItemListener() {

                public void itemStateChanged(ItemEvent ie) {
                    selected = new String[combos.length];
                    for (int i = 0; i < combos.length; i++) {
                        selected[i] = combos[i].getSelectedItem().toString();
                    }
                    //AttributesPanel.this.attributesNames.setAttributesNames(names);
                }
            });
        }
        boxCombos.updateUI();
        scrollCombos.updateUI();
        updateUI();

    }

    public void setAvailables(String[] av){
        availables = av;
        updateNbCombos();
    }

    public String[] getSelected(){
        return selected;
    }

}
