// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.util;
import java.text.NumberFormat;
import java.util.*;
import java.util.regex.*;

import com.bbn.openmap.Environment;

import fr.unicaen.openmap.dataStorage.*;
import fr.unicaen.openmap.util.*;


public class DataColumnValueComputer extends DataValueComputer {
    public static final String dataColumnNamePropertyString = "dataColumnName";
    private String dataColumnName = "data";

    public boolean equals(DataColumnValueComputer dc) {
	return this.dataColumnName.equals(dc.dataColumnName);
    }
    public String getDataColumnName() { return dataColumnName; }
    public void setDataColumnName(String s) { dataColumnName = s; }

    public DataColumnValueComputer(String dataColumnName) { 
	this.dataColumnName = dataColumnName; 
    }
    public double getValue(DataObject data) { 
	return Util.parseDouble(data.getData(dataColumnName)); 
    }
    public double getValue(double v) { 
	return v;
    }
    public String getString(DataObject data) {
	Object o = data.getData(dataColumnName);
	if (o == null)
		return null;
	if(o instanceof Double){
		NumberFormat df = NumberFormat.getIntegerInstance();
		return df.format((Double)o);
	}
		
	return o.toString();
	//return o == null ? null : o.toString();
    }
}
