// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.util;
import java.util.*;
import java.util.regex.*;

import fr.unicaen.openmap.dataStorage.*;
import fr.unicaen.openmap.util.*;


public class DataSquareRootColumnValueComputer extends DataColumnValueComputer {
    public DataSquareRootColumnValueComputer(String dataColumnName) { 
	super(dataColumnName); 
    }
    public double getValue(DataObject data) {
	double r = super.getValue(data);
	return r >= 0 ? Math.sqrt(r) : -Math.sqrt(-r);
    }
    public double getValue(double v) { 
	double r = super.getValue(v);
	return r >= 0 ? Math.sqrt(r) : -Math.sqrt(-r);
    }
}
