// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.util;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Properties;

import com.bbn.openmap.util.ColorFactory;
import com.bbn.openmap.util.Debug;


/**
 */
public class StandardColorScale extends AbstractColorScale {

    private String displayName = "";
    /** colorScales[i].getColorNumber() == i + 1 */
    private SimpleColorScale[] colorScales;
    public StandardColorScale(String name, String[] colorScalesInHex) {
	displayName = name;
	colorScales = new SimpleColorScale[colorScalesInHex.length];
	for (int i = 0; i < colorScalesInHex.length; i++) {
	    colorScales[i] = new SimpleColorScale(i+1, colorScalesInHex[i]);
	}
	//	currentColorScale = colorScales[getColorNumber()-1]
    }

    protected void initFromColorScaleInHex(int colorNumber, String colorScaleInHex) {
	Debug.error("*** Error call of StandardColorScale.initFromColorScaleInHex("+colorNumber+", \""+colorScaleInHex+"\")");
    }

    @Override
    public String getName() {
        return displayName;
    }
    
   public void setColorNumber(int nb) {	
       colorNumber = nb > colorScales.length ? colorScales.length : nb;
   }    
    public Color getColor(int index) {
        return index >= 0 && index < getColorNumber()
	    ? colorScales[getColorNumber()-1].getColor(index)
                : Color.white; // should return null in order to trap bad programming !-:
    }

    public void setColor(int index, Color color) {
	// error
    }

}
