// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu;

import java.util.ArrayList;

import javax.swing.JComponent;

import com.bbn.openmap.omGraphics.OMGraphicList;

import fr.unicaen.openmap.dataStorage.DataStorageIterator;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ChartPanel;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicGUI;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicPalette;

/**
 * Chart visualization mode: with the JFreeChart librairy 
 * @author jchauvea
 *
 */

public class Chart extends Raw{
	
	public enum ChartType {BAR,XY};
	
	private ChartType chartType; 
	
	private ArrayList<String> xNames;
	
	private int chartWidth = 150; 
	private int chartHeight = 150;
	
	private JComponent panGUI;
	private ChartPanel chartPan;
        
        protected int guiOrientation = ThematicPalette.AXIS;

	public Chart(ThematicDataDisplayLayer layer, String name) {
		super(layer, name);
		xNames = new ArrayList<String>();
	}
	
	public JComponent getGUI(DataStorageIterator dsi){
		thematicGUI = (ThematicGUI)super.getGUI(dsi);
		graphicsPanelToggleControlsDisplay(false);
		chartPan = new ChartPanel(this,dsi,thematicGUI, guiOrientation);
		thematicGUI.add(chartPan);
		
		return thematicGUI;
		
	}

	public ChartType getChartType() {
		return chartType;
	}

	public void setChartType(ChartType chartType) {
		this.chartType = chartType;
	}
	
	public OMGraphicList generateGraphics(DataStorageIterator dsi) {
		OMGraphicList omgl = new OMGraphicList();
//		double maxRange = 0;
//		try{
//			//first loop to compute max range value
//		while (dsi.hasNext()) {
//			DataObject data = dsi.next();
//			for(String name:xNames){
//				double val = Double.parseDouble(String.valueOf(data.getData(name)));
//				if(val>maxRange)
//					maxRange = val;
//			}
//		}
//		dsi.reset();
//		//second loop
//		while (dsi.hasNext()) {
//		DefaultCategoryDataset dataset = new DefaultCategoryDataset();
//		//row keys
//		final String serie1 = "name";
//		DataObject data = dsi.next();
//		OMDataLocation chartLocation = data.getOMDataLocation(geometryColumnName);
//			for(String name:xNames){
//				double val = Double.parseDouble(String.valueOf(data.getData(name)));
//				dataset.addValue(val, serie1, name);
//			}
//			JFreeChart chart;
//			if(chartType == ChartType.BAR){
//
//				chart = ChartFactory.createBarChart(
//			            "",       					// chart title
//			            chartPan.getXTitle(),       // domain axis label
//			            chartPan.getYTitle(),       // range axis label
//			            dataset,                   	// data
//			            PlotOrientation.VERTICAL,  	// orientation
//			            false,                     	// include legend
//			            false,                     	// tooltips
//			            false                      	// urls
//			        );
//			}
//			else{
//				chart = ChartFactory.createLineChart(
//			            "",
//			            chartPan.getXTitle(),
//			            chartPan.getYTitle(),
//			            dataset,
//			            PlotOrientation.VERTICAL,
//			            false,
//			            false,
//			            false
//			        );
//			}
//
//
//			CategoryPlot plot = (CategoryPlot) chart.getPlot();
//			plot.setDomainGridlinesVisible(false);
//			ValueAxis axis = plot.getRangeAxis();
//			CategoryAxis cat = plot.getDomainAxis();
//
//			cat.setVisible(false);
//			axis.setVisible(false);
//			NumberAxis rangeAxis = (NumberAxis) plot.getRangeAxis();
//			CategoryItemRenderer renderer = plot.getRenderer();
//			renderer.setSeriesPaint(0, colors.getRealFillColor());
//			renderer.setSeriesStroke(0, stroke);
//			rangeAxis.setRange(0, maxRange);
//			chart.clearSubtitles();
//			plot.setOutlineVisible(false);
//
//			Color c = new Color(255,255,255,0);
//			plot.setBackgroundPaint(c);
//			chart.setBackgroundPaint(c);
//
//			BufferedImage bimg = chart.createBufferedImage(chartWidth, chartHeight);
//			ImageIcon img = new ImageIcon(bimg);
//			try {
//			    OMPictogram omp =
//				new OMPictogram((float)chartLocation.getCentroid().getLat(),
//						(float)chartLocation.getCentroid().getLon(),
//						img);
//			    omgl.add(omp);
//			} catch(java.lang.NullPointerException e) {
//			    System.err.println("**** Exception for Chart ");
//			}
//
//		}
//
//		return omgl;
//		}
//		catch(Exception e){e.printStackTrace();return null;}
                return omgl;
	}
	
	public void addXName(String name){
		xNames.add(name);
	}
	
	public boolean removeXName(String name){
		
		return xNames.remove(name);
	}

	public int getChartHeight() {
		return chartHeight;
	}

	public void setChartHeight(int chartHeight) {
		this.chartHeight = chartHeight;
	}

	public int getChartWidth() {
		return chartWidth;
	}

	public void setChartWidth(int chartWidth) {
		this.chartWidth = chartWidth;
	}
	


}
