// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu;
import java.util.Properties;
import javax.swing.JComponent;


import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.MouseControlPointsListener;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.*;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend.*;
import fr.unicaen.openmap.util.*;

import com.bbn.openmap.omGraphics.*;
import com.bbn.openmap.event.*;
import fr.unicaen.openmap.event.RefreshableGUI;
import com.bbn.openmap.I18n;
import com.bbn.openmap.BasicI18n;
import com.bbn.openmap.proj.Projection;
import com.bbn.openmap.util.Debug;
import com.bbn.openmap.util.PropUtils;
import fr.unicaen.openmap.dataStorage.DataStorageIterator;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicGUI;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.ThematicPalette;
import fr.unicaen.openmap.event.RefreshableGUI;

public interface Visu extends RefreshableGUI {
    public ThematicDataDisplayLayer getLayer();

    public void setProperties(String prefix, Properties properties);
    public Properties getProperties(String prefix, Properties properties);

    public OMGraphicList getInteractiveGraphics();

    public void addInteractiveGraphic(OMGraphic omg);
    public void removeInteractiveGraphic(OMGraphic omg);
    public void removeGraphic(OMGraphic g);

    public void clearInteractiveGraphics();
    public void refresh();

    public JComponent getGUI(final DataStorageIterator dsi);
    public void refreshGUI(DataStorageIterator dsi);


}
