// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.utils;

import com.bbn.openmap.Layer;
import com.bbn.openmap.LayerHandler;
import fr.unicaen.openmap.AtlasLayerHandler;
import java.io.IOException;
import java.net.URL;

/**
 *
 * @author jchauvea
 */
public class AtlasLayerLoader extends LayerLoader {

    public AtlasLayerLoader(URL url, AtlasLayerHandler layerHandler) {
        super(url, layerHandler);
    }

    @Override
	public Layer initLayer(String layerName) {
        String classProperty = layerName + ".class";
        //System.out.println("INIT -> " + classProperty);
        String className = properties.getProperty(classProperty);
	if (className == null)
	    return null;
        Object obj;
        try {
            obj = java.beans.Beans.instantiate(null, className);
            if (obj instanceof Layer) {
                Layer l = (Layer) obj;
                l.setName(properties.getProperty(layerName + "." + Layer.PrettyNameProperty));
                ((AtlasLayerHandler)layerHandler).addLoadableLayer(l, layerName, properties);
                return l;
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
        return null;
    }
}
