// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.layer.utils;

import com.bbn.openmap.Layer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.ThematicDataDisplayLayer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Map;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author jchauvea
 */
public class LayerExporter {

    public static void exportLayer(ThematicDataDisplayLayer layer, PrintStream ps){

        Properties properties = layer.getProperties(new Properties());
        //print layer name as value for the openmap.layers property
        ps.println(LayerLoader.KEY_LAYERS+" = " +layer.getPropertyPrefix());
        //layer class
        ps.println(layer.getPropertyPrefix()+"."+LayerLoader.KEY_CLASS+" = " +layer.getClass());
        ArrayList<Thematic> tvs = layer.getThematicArray();
        for (Map.Entry<Object, Object> currentEntry : properties.entrySet()){
            ps.println(currentEntry.getKey() +" = "+currentEntry.getValue());

    }
    }

}
