// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.wmsLayer;

import fr.unicaen.openmap.layer.wmsLayer.WMSLayer;
import java.util.ArrayList;
import java.util.HashMap;

public class DummyWMSLayer
{
	private ArrayList<String> _layers;
	private HashMap<String, Boolean> _state;
	private WMSLayer _parent;
	private String _name;

	public DummyWMSLayer( String name, WMSLayer parent, ArrayList<String> layers, HashMap<String, Boolean> state )
	{
		_name = name;
		_parent = parent;
		_layers = layers;
		_state = state;
		_layers.add(_name);
	}

	public boolean isVisible()
	{
		return _state.get(_name);
	}

	public void setVisible( boolean v )
	{
		_state.put( _name, v );
	}

	public void remove()
	{
		_state.remove(_name);
		_layers.remove(_name);
	}

	public WMSLayer getParent()
	{
		return _parent;
	}

	public String name()
	{
		return _name;
	}
}
