// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.layer.wmsLayer;

import fr.unicaen.openmap.layer.thematicDataDisplayLayer.visu.Thematic;
import fr.unicaen.openmap.util.Util;
import java.awt.Color;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import fr.unicaen.openmap.gui.ThemaMapTreeNodeComponent;
import fr.unicaen.openmap.gui.LayersTree;

public class WMSTreeNodeComponent extends ThemaMapTreeNodeComponent
{
    protected DummyWMSLayer _wms;

    public WMSTreeNodeComponent(LayersTree tree, DummyWMSLayer wms)
	{
		super(tree);
		_wms = wms;
        this.tree = tree;
        setBackground(Color.WHITE);
        add(getOnOffButton());
        add(new JLabel(getTVImageIcon()));
        lab = new JLabel(wms.name());
        add(lab);
        repaint();
    }

    private ImageIcon getTVImageIcon()
	{
        return Util.loadIcon("visu/Raw.png");
    }

    protected JToggleButton getOnOffButton()
	{
        JCheckBox b = new JCheckBox( _wms.isVisible() ? Util.loadIcon("enabled.png") : Util.loadIcon("disabled.png"), _wms.isVisible());
        b.setBorder(null);
        b.setBorderPainted(false);
        b.setFocusPainted(false);
        b.setBackground(Color.WHITE);
        b.setOpaque(false);
        b.setFocusable(true);
        b.addItemListener(new ItemListener()
		{
            public void itemStateChanged(ItemEvent e)
			{
                if (WMSTreeNodeComponent.this.getBackground() != Color.LIGHT_GRAY)
				{
                    WMSTreeNodeComponent.this.setBackground(Color.LIGHT_GRAY);
                }
                JCheckBox bsource = (JCheckBox) e.getSource();
               if (e.getStateChange() == ItemEvent.SELECTED)
				{
                    bsource.setIcon(Util.loadIcon("enabled.png"));
                    _wms.setVisible(true);
                }
				else
				{
                    bsource.setIcon(Util.loadIcon("disabled.png"));
                    _wms.setVisible(false);
                }
            }
        });
        return b;
    }
}
