// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.tools.drawing;

import com.bbn.openmap.I18n;
import com.bbn.openmap.tools.drawing.OMDrawingTool;
import com.bbn.openmap.omGraphics.EditableOMGraphic;
import com.bbn.openmap.omGraphics.EditableOMPoly;
import com.bbn.openmap.omGraphics.OMAction;
import com.bbn.openmap.omGraphics.OMGraphic;
import com.bbn.openmap.omGraphics.OMGraphicConstants;
import com.bbn.openmap.util.Debug;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;

import javax.swing.JPopupMenu;
import javax.swing.JMenuItem;
import javax.swing.JComponent;
import javax.swing.SwingConstants;

import fr.unicaen.openmap.Environment;

import com.bbn.openmap.MapBean;

/**
 *
 * @author JAcques.Madeliane@unicaen.fr
 */
public class TMDrawingTool extends OMDrawingTool {

  public JPopupMenu createPopupMenu() {        
      I18n i18n = Environment.getI18n();
      EditableOMGraphic eomg = getCurrentEditable();
      JPopupMenu pum = new JPopupMenu();
      if (eomg instanceof EditableOMPoly) {
	  EditableOMPoly eomp = ((EditableOMPoly)eomg);
	  pum.add(eomp.getPolyGUI(true, false, true, true, SwingConstants.HORIZONTAL, null));
	  eomp.enablePolygonEditButtons(true);
      }
      return pum.getComponentCount() > 0 ? pum : null;
   }
}
