// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.tools.drawing;

import com.bbn.openmap.omGraphics.OMGraphic;
import com.bbn.openmap.tools.drawing.DrawingTool;
import com.bbn.openmap.tools.drawing.DrawingToolRequestor;
import com.bbn.openmap.tools.drawing.OMDrawingTool;
import com.bbn.openmap.tools.drawing.OMDrawingToolLauncher;
import com.bbn.openmap.util.Debug;

import fr.unicaen.openmap.dataStorage.EditableDataStorage;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;
import java.util.ArrayList;
import javax.swing.JMenuItem;
import javax.swing.JComponent;


import com.bbn.openmap.InformationDelegator;
import com.bbn.openmap.MapHandler;
import com.bbn.openmap.omGraphics.GraphicAttributes;
import com.bbn.openmap.tools.drawing.EditToolLoader;
import com.bbn.openmap.util.PaletteHelper;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.util.Vector;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;

/**
 *
 * @author jchauvea
 */
public class TMDrawingToolLauncher extends OMDrawingToolLauncher {


    public TMDrawingToolLauncher(){
        super();
        defaultGraphicAttributes.setLineType(OMGraphic.LINETYPE_STRAIGHT);
    }

    /**
     * Set the component that will receive the new/edited OMGraphic from the
     * DrawingTool. 
     */
    public void setCurrentRequestor(DrawingToolRequestor r) {
        currentRequestor = r;
    }

    public List<Component> getContextualMenu() {
	ArrayList<Component> components = new ArrayList<Component>();

	for (LoaderHolder lh : loaders) {        
	    final String pName = lh.prettyName;

	    JMenuItem item = new JMenuItem("Create a "+pName);
	    components.add(item);
	    item.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent ae) {
			setCurrentCreation(pName);
			ActionEvent actionCreate = new ActionEvent(ae.getSource(), ae.getID(), OMDrawingToolLauncher.CreateCmd);
			TMDrawingToolLauncher.this.actionPerformed(actionCreate);
		    }
		});
	}
	return components;
    }

}
