// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Color;
import javax.swing.Icon;

public class ColorIcon implements Icon {
    private Color color;
    private int width = 56;
    private int height = 18;
    public ColorIcon(Color color) { this.color = color; }
    public ColorIcon(Color color, int width, int height) {
	this.color = color; this.width = width; this.height = height; 
    }
    public void setColor(Color color) { this.color = color; }
    public Color getColor() { return color; }
    public int getIconWidth() { return width; }
    public int getIconHeight() { return height; }
    
    public void paintIcon(Component c, Graphics g, int x, int y) {
	g.setColor(Color.gray);
	g.fillRect(x, y, getIconWidth(), getIconHeight());
	g.setColor(color);
	g.fillRect(x + 1, y + 1, getIconWidth() - 2, getIconHeight() - 2);
    }
}
