// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util;

/* YL */

import com.bbn.openmap.proj.coords.LatLonPoint;

/**
 * Use to transform LatLonPoint in float[], or contrary.
 */
public class Convert
{
    /**
     * Returns a float[] with latitude in 0 and longitude in 1
     * @param p LatLonPoint representation
     * @return a float[] representation of LatLonPoint
     */
    public static float[] transform(LatLonPoint p)
    {
	float[] res = {p.getLatitude(),p.getLongitude()};

	return res;
    }

    /**
     * Returns a new LatLonPoint with p[0] as latitude and p[1] as longitude.
     * @param p coords with latitude in 0 and longitude in 1
     * @return a new LatLonPoint representation of float[]
     */
    public static LatLonPoint transform(float[] p)
    {
	return new LatLonPoint.Double(p[0],p[1]);
    }
}
