// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util;

import java.awt.*;
import java.awt.event.*;
import java.awt.print.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

/**
 *
 */
public class PrintThread extends Thread implements ActionListener {
    
    private JFrame owner = null;
    private Printable toPrint = null;
    private String documentTitle = "";
    
    /**
     *
     */
    public PrintThread (JFrame owner, Printable toPrint, String documentTitle) throws Exception {
	if (System.getProperty("os.name").startsWith("Win"))
	    throw new Exception("[PrintThread]  Printing under windows is not supported.");
	this.owner = owner;
	this.toPrint = toPrint;
	this.documentTitle = documentTitle;
    }

    /**
     *
     */
    public void run() {
	System.err.println("[PrintThread] starts");
	boolean win = (System.getProperty("os.name").startsWith("Win"));
	Properties printProperties = new Properties();
	printProperties.put("awt.print.destination", (win ? "printer" : "file"));
	printProperties.put("awt.print.fileName", (win ? "" : "/tmp/output.ps"));
	printProperties.put("awt.print.paperSize", "a4");
	PrintJob job = Toolkit.getDefaultToolkit().getPrintJob(owner, documentTitle, printProperties);
	if(job != null) {
	    Graphics graphics = job.getGraphics();
	    try {
		toPrint.print(graphics, new PageFormat(), 1);
	    } catch (Exception e) { }
	    graphics.dispose();
	    job.end();
	}
	else System.err.println("[PrintThread] print canceled");
	System.err.println("[PrintThread] ends");
    }

    /**
     *
     */
    public void actionPerformed(ActionEvent e) { }
}
