// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util;

import java.util.ArrayList;

public class UnicaenPropUtils {

    public static ArrayList<String> arrayListFromProperties(java.util.Properties p, java.lang.String propName, String delim) {
	String tokensList = p.getProperty(propName, "");
	String[] tokensArray = tokensList.split(delim);
	ArrayList<String> tokensArrayList = new ArrayList<String>(tokensArray.length);
	for (String t : tokensArray) {
	    t = t.trim();
            if (t.length() > 0)
                tokensArrayList.add(t);
	}
	return tokensArrayList;
    }

    public static void arrayListToPropertyString(java.util.Properties p, java.lang.String propName, ArrayList<String> l, String delim) {
	if (l == null)
	    return;
	StringBuilder stringList = new StringBuilder();
	for (String s : l) {
	    stringList.append(s);
	    stringList.append(delim);
	}
	p.put(propName, stringList.toString());
    }	
}
