// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.classification;

import java.util.ArrayList;
import java.util.Collections;
import com.bbn.openmap.util.*;


/**
 * Arithmetic Step Classification : the class widths follow an arithmetic progression.
 */
public class ArithmeticStepClassification extends StepClassification {

    public ArithmeticStepClassification(ArrayList<Double> data, int nbClasses) {
	super(data, nbClasses);
    }
    
    public ArithmeticStepClassification(ClassificationOfDouble c, int nbClasses) {
	super(c.data, nbClasses);
    }

    protected void setBreaks(double min, double max) {	
	int step = (int)Math.ceil((max-min)/nbClasses);
	nbClasses = (int)Math.ceil((max-min)/step);
	breaks = new double[nbClasses+1];
	for(int i = 0; i <= nbClasses; i++)
	    breaks[i] = min + i * step;
    }
}
