// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.classification;

import java.util.ArrayList;
import java.util.Collections;

/**
 * on progress...
function [partitions,hauteurs]=classification(X)

// classification hierachique descendante 
// ecart = norme euclidienne
// distance minimale

G=X'*X;// Gram < F_i,F_j>
D=real(ones(G)*diag(diag(G))+diag(diag(G))*ones(G)-2*real(G)); // ||F_i-F_j||^2
// exemple FK
//D=[0 .3 10 17 1.8 4.8;.3 0. 7.1 13 .6 2.8;10 7.1 0 1.2 3.6 1.4;17 13 1.2 0 8.0 5.0;1.8 .6 3.6 8 0 1;4.8 2.8 1.4 5.0 1.0 0.]
partitions=tlist('debut');
classe=tlist('partition');
for i=1:size(D,1),classe(i)=[i];end;
hauteurs=[];

while size(D,1)> 1 then
  nb=size(D,1);
  [m,k]=min(D+1.E20*eye(D))
  
  classe(k(1))=[classe(k(1)) classe(k(2))];
  classe(k(2))=null();
  L=min(D(k(1),:),D(k(2),:));
  D(k(1),:)=L;
  D(:,k(1))=L';
  indices=(1:nb)~=k(2);
  D=D(indices,indices);
  cl=null();for i=1:size(classe),cl(string(i))=classe(i);end;
  partition.classe=cl;
  partition.hauteur=m;
  hauteurs=[m;hauteurs];
  partitions($+1)=partition;
end;
endfunction


 */
public class HierarchicalClassification extends ClassificationOfDouble {

    public HierarchicalClassification(ArrayList<Double> data, int nbClasses) {
	super(data, nbClasses);
    }
    
    //une classe pour Classes ???
    ArrayList<ArrayList<Double>> classes;

    protected void initBreaks() {
	breaks = new double[nbClasses+1];
	breaks[0] = data.get(0); // first break is the min value;
	breaks[nbClasses] = data.get(data.size()-1); // last break is the max value

	for(int i = 0; i <= nbClasses; i++)
	    breaks[i] = i;
    }
}
