// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.classification;

import java.util.ArrayList;
import java.util.Collections;

/**
 * Computes quantiles i.e. classes with the same cardinal
 * <p>problem with this implementation exists in case of many equals values...
 */
public class Quantile extends ClassificationOfDouble {

    public Quantile(ArrayList<Double> data, int nbClasses) {
	super(data, nbClasses);
    }
    
    protected void initBreaks() {
	double N = data.size();
	for (int i = 1; i < nbClasses; i++) {
	    int d = (int)Math.floor(i*N/nbClasses);
	    // the mean value of data at d and d+1
	    breaks[i] = (d+1) >= N ?  data.get(data.size()-1)
		: (data.get(d)+data.get(d+1))/2;
	}
    }

}
