// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.legendable;

import com.bbn.openmap.omGraphics.OMGraphicList;


import fr.unicaen.openmap.layer.legendLayer.LegendLayer;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.MouseControlPointsListener;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.gui.LegendGUIManager;
import fr.unicaen.openmap.layer.thematicDataDisplayLayer.omGraphics.legend.OMResizeableGraphicList;
import java.awt.Component;
import java.util.Properties;

public interface LegendableLayer
{

    /**
     * Should return an OMGraphicList representation for the legend.
     */
    //prévoir de plutôt opérer avec un futur objet Legend, 
    //cela permettra une manipulation à la souris et une personnalisation plus fine d'une légende,
    //on pourra ainsi avoir des DiscLegend & FlowLegend dérivant de Legend... tbc...

    public LegendGUIManager legendManager = new LegendGUIManager();

    public OMResizeableGraphicList getLegend(LegendLayer legend);

    public void setLegendProperties(String prefix, Properties properties);

    public Properties getLegendProperties(String prefix, Properties properties);

    public String getName();
    
}
