// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.legendable;

import java.awt.event.ActionEvent;
import javax.swing.*;
import javax.swing.text.*;

import fr.unicaen.openmap.util.JActionButton;


//author : Yannick Lange, ylange@etu.info.unicaen.fr, DESS NAPI, juin-septembre 2003.
public class LegendablePanel extends JPanel
{
    /**
     * LegendableLayer associated with panel.
     */
    protected LegendableLayer layer;

    /**
     * Contains title.
     * Fact to have a JTextComponent as type (and not a extended class) allows you to change default type (JTextField) if you need.
     */
    protected JTextComponent title;


    /**
     * Creates a panel to change legend title for a layer.
     * @param layer LegendableLayer
     */
    public LegendablePanel(LegendableLayer layer)
    {
	this.layer = layer;

	setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

	////title = new JTextField(getLayer().getTitle(), 30);

	JActionButton ok = new JActionButton("Ok")
	    {
		public void actionPerformed(ActionEvent ae)
		{
		   //// getLayer().setTitle(getTitle().getText());
		}
	    };

	JPanel panel = new JPanel();
	panel.add(new JLabel("Legend title : "));
	panel.add(title);
	panel.add(ok);

	add(panel);
    }

    /**
     * Returns LegendableLayer associated at this panel.
     * @return LegendableLayer.
     */
    public LegendableLayer getLayer()
    {
	return layer;
    }

    /**
     * Returns Component where title is.
     * @return JTextField.
     */
    public JTextComponent getTitle()
    {
	return title;
    }
}
