// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.util.propertyEditor;

import fr.unicaen.openmap.util.Util;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.beans.PropertyEditorSupport;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JPanel;
import javax.swing.JComboBox;
import java.util.Vector;

public abstract class ComboBoxPropertyEditor extends PropertyEditorSupport{

    protected JComboBox cBox;
	protected Vector<String> content;

	public ComboBoxPropertyEditor()
	{
		fill();
	}

	protected abstract void fill();

    public boolean supportsCustomEditor() {
        return true;
    }

    public Component getCustomEditor() {
		Box box = Box.createHorizontalBox();
		cBox = new JComboBox( content );
		cBox.setEditable(true);
		box.add(cBox);

		return box;
    }

    public void setValue(Object string) {
		int idx = -1;

		for( int i = 0 ; i < cBox.getItemCount() ; i++ )
		{
			if( cBox.getItemAt(i).equals( string ) )
			{
				idx = i;
				continue;
			}
		}

		if( idx != -1 )
		{
			cBox.setSelectedIndex(idx);
		}
		else
		{
			cBox.insertItemAt(string, 0);
			cBox.setSelectedIndex(0);
		}
    }

    public String getAsText() {
        return ""+cBox.getSelectedItem();
    }


}
