// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>
package fr.unicaen.openmap.util.propertyEditor;


import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;

import fr.unicaen.openmap.dataStorage.DataStorage;
import fr.unicaen.openmap.util.Util;

import com.bbn.openmap.util.PropUtils;

public class QualitativeAnalysisPropertyEditor extends DataStoragePropertyEditor {

    protected String getDSClassName() {
	return 	"fr.unicaen.openmap.dataStorage.QualitativeAnalysisDataStorage";
    }
    
    public Component getCustomEditor() {
	JPanel panel = new JPanel();
	JPanel dsPanel = new JPanel();
	
	dsPanel.setLayout(new BoxLayout(dsPanel, BoxLayout.Y_AXIS));
	
	DataStorage ds = Util.createDataStorage(getDSClassName(), this);
	prefix = PropUtils.getScopedPropertyPrefix(ds.getPropertyPrefix());
	
	//		    inspector.inspectPropertyConsumer(ds); //not exactly what we want : pop-up again, useless buttons...
	JComponent component = (JComponent)inspector.createPropertyGUI(ds);
	component.remove(((BorderLayout)(component.getLayout())).getLayoutComponent(component, BorderLayout.SOUTH)); //remove buttons Ok/Cancel
	
	//we already have so much pop-up, prefer :
	panel.setVisible(false);
	dsPanel.removeAll();
	// dsPanel.add(new JLabel(getDSClassName()));
	//		    dsPanel.add(inspector.createPropertyGUI(ds));
	dsPanel.add(component);
	panel.setVisible(true);
	
	panel.add(dsPanel);
	panel.setPreferredSize(new Dimension(500, 300));
	panel.setBorder(BorderFactory.createTitledBorder(""));
	return panel;
    }
}
