// <header>
/**
 *  ThemaMap : The Thematic Maps Production Tool
 *
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, Certic
 *  Copyright (c) 2008-2012 Université de Caen Basse-Normandie, GREYC
 *                     		
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  <http://www.gnu.org/licenses/>
 *
 *  See http://themamap.info.unicaen.fr/authors/
 *      for a list of contributors 
 */
// </header>

package fr.unicaen.openmap.util.propertyEditor;

import fr.unicaen.openmap.dataStorage.postgis.gui.QueryTextPane;
import fr.unicaen.openmap.util.ContentFileLoader;
import fr.unicaen.openmap.util.Util;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyEditorSupport;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 *
 * @author jchauvea
 */
public class TextAreaPropertyEditor extends PropertyEditorSupport{


     protected QueryTextPane area;

    public boolean supportsCustomEditor() {
        return true;
    }

    public Component getCustomEditor() {
	Box box = Box.createHorizontalBox();
	area = new QueryTextPane("");
        area.setBorder(BorderFactory.createEtchedBorder(Color.gray, Color.white));
        area.setMaximumSize(new Dimension(300,100));
        area.setPreferredSize(new Dimension(300,100));
        area.setMinimumSize(new Dimension(300,100));
	box.add(area);

        JButton bImportSQL = new JButton(Util.loadIcon("Import16.png"));
        bImportSQL.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent arg0) {
                JFileChooser jfc = new JFileChooser(".");
                FileNameExtensionFilter filter = new FileNameExtensionFilter(
		        "SQL files", "sql");
                jfc.setFileFilter(filter);
                if(jfc.showOpenDialog(area) == JFileChooser.APPROVE_OPTION){
                    area.setText(
                            ContentFileLoader.loadContent(jfc.getSelectedFile()));
                }
            }
        });

        JPanel pButton = new JPanel();
        pButton.add(bImportSQL);
        bImportSQL.setMaximumSize(new Dimension(20, 15));
        bImportSQL.setPreferredSize(new Dimension(20, 15));
        bImportSQL.setMinimumSize(new Dimension(20, 15));
        pButton.setBorder(BorderFactory.createEmptyBorder(0, 20, 0, 20));

        box.add(pButton);
	return box;
    }

	public void setValue(Object string) {
		area.setText(""+string);
	}

    public String getAsText() {
        return area.getText();
    }


}
